"use strict";
(globalThis["webpackChunkpeertube_client"] = globalThis["webpackChunkpeertube_client"] || []).push([["src_assets_player_shared_web-video_web-video-plugin_ts"],{

/***/ "./src/assets/player/shared/web-video/web-video-plugin.ts":
/*!****************************************************************!*\
  !*** ./src/assets/player/shared/web-video/web-video-plugin.ts ***!
  \****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   WebVideoPlugin: () => (/* binding */ WebVideoPlugin)
/* harmony export */ });
/* harmony import */ var debug__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! debug */ "./node_modules/debug/src/browser.js");
/* harmony import */ var debug__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(debug__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _root_helpers_logger__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @root-helpers/logger */ "./src/root-helpers/logger.ts");
/* harmony import */ var _peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @peertube/peertube-core-utils */ "../packages/core-utils/dist/index.js");




const debugLogger = debug__WEBPACK_IMPORTED_MODULE_0___default()('peertube:player:web-video-plugin');
const Plugin = video_js__WEBPACK_IMPORTED_MODULE_1___default().getPlugin('plugin');
class WebVideoPlugin extends Plugin {
  constructor(player, options) {
    super(player, options);
    this.videoFiles = options.videoFiles;
    this.videoFileToken = options.videoFileToken;
    const videoFile = this.pickAverageVideoFile();
    if (videoFile) this.updateVideoFile({
      videoFile,
      isUserResolutionChange: false
    });
    this.onLoadedMetadata = () => {
      player.trigger('video-ratio-changed', {
        ratio: this.player.videoWidth() / this.player.videoHeight()
      });
    };
    player.on('loadedmetadata', this.onLoadedMetadata);
    player.ready(() => {
      if (this.videoFiles.length === 0) {
        this.player.addClass('disabled');
        return;
      }
      this.buildQualities();
      this.setupNetworkInfoInterval();
    });
  }
  dispose() {
    if (this.networkInfoInterval) clearInterval(this.networkInfoInterval);
    if (this.onLoadedMetadata) this.player.off('loadedmetadata', this.onLoadedMetadata);
    if (this.onErrorHandler) this.player.off('error', this.onErrorHandler);
    if (this.onPlayHandler) this.player.off('canplay', this.onPlayHandler);
    super.dispose();
  }
  getCurrentResolutionId() {
    var _this$currentVideoFil;
    return (_this$currentVideoFil = this.currentVideoFile) === null || _this$currentVideoFil === void 0 ? void 0 : _this$currentVideoFil.resolution.id;
  }
  updateVideoFile(options) {
    this.currentVideoFile = options.videoFile;
    debugLogger('Updating web video file to ' + this.currentVideoFile.fileUrl);
    const paused = this.player.paused();
    const playbackRate = this.player.playbackRate();
    const currentTime = this.player.currentTime();
    if (!this.onErrorHandler) {
      this.onErrorHandler = () => this.player.peertube().displayFatalError();
      this.player.one('error', this.onErrorHandler);
    }
    let httpUrl = this.currentVideoFile.fileUrl;
    if (this.videoFileToken()) {
      httpUrl = (0,_peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_3__.addQueryParams)(httpUrl, {
        videoFileToken: this.videoFileToken()
      });
    }
    const oldAutoplayValue = this.player.autoplay();
    if (options.isUserResolutionChange) {
      this.player.autoplay(false);
      this.player.addClass('vjs-updating-resolution');
    }
    this.player.src(httpUrl);
    this.onPlayHandler = () => {
      var _this$currentVideoFil2;
      this.player.playbackRate(playbackRate);
      this.player.currentTime(currentTime);
      this.player.trigger('resolution-change', {
        resolution: (_this$currentVideoFil2 = this.currentVideoFile) === null || _this$currentVideoFil2 === void 0 ? void 0 : _this$currentVideoFil2.resolution.id,
        initResolutionChange: !options.isUserResolutionChange
      });
      if (options.isUserResolutionChange) {
        this.player.trigger('web-video-source-change');
        this.tryToPlay().then(() => {
          if (paused) this.player.pause();
          this.player.autoplay(oldAutoplayValue);
        });
      }
    };
    this.player.one('canplay', this.onPlayHandler);
  }
  getCurrentVideoFile() {
    return this.currentVideoFile;
  }
  tryToPlay() {
    debugLogger('Try to play manually the video');
    const playPromise = this.player.play();
    if (playPromise === undefined) return;
    return playPromise.catch(err => {
      if (err.message.includes('The play() request was interrupted by a call to pause()')) {
        return;
      }
      _root_helpers_logger__WEBPACK_IMPORTED_MODULE_2__.logger.warn(err);
      this.player.pause();
      this.player.posterImage.show();
      this.player.removeClass('vjs-has-autoplay');
      this.player.removeClass('vjs-playing-audio-only-content');
    }).finally(() => {
      this.player.removeClass('vjs-updating-resolution');
    });
  }
  pickAverageVideoFile() {
    if (!this.videoFiles || this.videoFiles.length === 0) return undefined;
    if (this.videoFiles.length === 1) return this.videoFiles[0];
    const files = this.videoFiles.filter(f => f.resolution.id !== 0);
    return files[Math.floor(files.length / 2)];
  }
  buildQualities() {
    const resolutions = this.videoFiles.map(videoFile => {
      var _this$currentVideoFil3;
      return {
        id: videoFile.resolution.id,
        label: this.buildQualityLabel(videoFile),
        height: videoFile.resolution.id,
        selected: videoFile.id === ((_this$currentVideoFil3 = this.currentVideoFile) === null || _this$currentVideoFil3 === void 0 ? void 0 : _this$currentVideoFil3.id),
        selectCallback: () => this.updateVideoFile({
          videoFile,
          isUserResolutionChange: true
        })
      };
    });
    this.player.peertubeResolutions().add(resolutions);
  }
  buildQualityLabel(file) {
    let label = file.resolution.label;
    if (file.fps && file.fps >= 50) {
      label += file.fps;
    }
    return label;
  }
  setupNetworkInfoInterval() {
    this.networkInfoInterval = setInterval(() => {
      var _this$currentVideoFil4;
      return this.player.trigger('network-info', {
        source: 'web-video',
        http: {
          downloaded: this.player.bufferedPercent() * ((_this$currentVideoFil4 = this.currentVideoFile) === null || _this$currentVideoFil4 === void 0 ? void 0 : _this$currentVideoFil4.size)
        }
      });
    }, 1000);
  }
}
video_js__WEBPACK_IMPORTED_MODULE_1___default().registerPlugin('webVideo', WebVideoPlugin);


/***/ })

}]);
//# sourceMappingURL=src_assets_player_shared_web-video_web-video-plugin_ts.49b3cbb2a80f8ed15b5d.chunk.js.map