"use strict";
(globalThis["webpackChunkpeertube_client"] = globalThis["webpackChunkpeertube_client"] || []).push([["src_assets_player_peertube-player_ts"],{

/***/ "./src/assets/player/peertube-player-local-storage.ts":
/*!************************************************************!*\
  !*** ./src/assets/player/peertube-player-local-storage.ts ***!
  \************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   cleanupVideoWatch: () => (/* binding */ cleanupVideoWatch),
/* harmony export */   getAverageBandwidthInStore: () => (/* binding */ getAverageBandwidthInStore),
/* harmony export */   getPlayerSessionId: () => (/* binding */ getPlayerSessionId),
/* harmony export */   getStoredLastSubtitle: () => (/* binding */ getStoredLastSubtitle),
/* harmony export */   getStoredMute: () => (/* binding */ getStoredMute),
/* harmony export */   getStoredPreferredSubtitle: () => (/* binding */ getStoredPreferredSubtitle),
/* harmony export */   getStoredTheater: () => (/* binding */ getStoredTheater),
/* harmony export */   getStoredVideoWatchHistory: () => (/* binding */ getStoredVideoWatchHistory),
/* harmony export */   getStoredVolume: () => (/* binding */ getStoredVolume),
/* harmony export */   saveAverageBandwidth: () => (/* binding */ saveAverageBandwidth),
/* harmony export */   saveLastSubtitle: () => (/* binding */ saveLastSubtitle),
/* harmony export */   saveMuteInStore: () => (/* binding */ saveMuteInStore),
/* harmony export */   savePreferredSubtitle: () => (/* binding */ savePreferredSubtitle),
/* harmony export */   saveTheaterInStore: () => (/* binding */ saveTheaterInStore),
/* harmony export */   saveVideoWatchHistory: () => (/* binding */ saveVideoWatchHistory),
/* harmony export */   saveVolumeInStore: () => (/* binding */ saveVolumeInStore)
/* harmony export */ });
/* harmony import */ var _root_helpers_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @root-helpers/logger */ "./src/root-helpers/logger.ts");
/* harmony import */ var _root_helpers_peertube_web_storage__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @root-helpers/peertube-web-storage */ "./src/root-helpers/peertube-web-storage.ts");
/* harmony import */ var _root_helpers_string__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @root-helpers/string */ "./src/root-helpers/string.ts");



function getStoredVolume() {
  const value = getLocalStorage('volume');
  if (value !== null && value !== undefined) {
    const valueNumber = parseFloat(value);
    if (isNaN(valueNumber)) return undefined;
    return valueNumber;
  }
  return undefined;
}
function getStoredMute() {
  const value = getLocalStorage('mute');
  if (value !== null && value !== undefined) return value === 'true';
  return undefined;
}
function getStoredTheater() {
  const value = getLocalStorage('theater-enabled');
  if (value !== null && value !== undefined) return value === 'true';
  return false;
}
function saveVolumeInStore(value) {
  return setLocalStorage('volume', value.toString());
}
function saveMuteInStore(value) {
  return setLocalStorage('mute', value.toString());
}
function saveTheaterInStore(enabled) {
  return setLocalStorage('theater-enabled', enabled.toString());
}
function saveAverageBandwidth(value) {
  /** used to choose the most fitting resolution */
  return setLocalStorage('average-bandwidth', value.toString());
}
function getAverageBandwidthInStore() {
  const value = getLocalStorage('average-bandwidth');
  if (value !== null && value !== undefined) {
    const valueNumber = parseInt(value, 10);
    if (isNaN(valueNumber)) return undefined;
    return valueNumber;
  }
  return undefined;
}
// ---------------------------------------------------------------------------
function saveLastSubtitle(language) {
  return setLocalStorage('last-subtitle', language);
}
function getStoredLastSubtitle() {
  return getLocalStorage('last-subtitle');
}
function savePreferredSubtitle(language) {
  return setLocalStorage('preferred-subtitle', language);
}
function getStoredPreferredSubtitle() {
  return getLocalStorage('preferred-subtitle');
}
// ---------------------------------------------------------------------------
function saveVideoWatchHistory(videoUUID, duration) {
  return setLocalStorage("video-watch-history", JSON.stringify({
    ...getStoredVideoWatchHistory(),
    [videoUUID]: {
      duration,
      date: "".concat(new Date().toISOString())
    }
  }));
}
function getStoredVideoWatchHistory(videoUUID) {
  let data;
  try {
    const value = getLocalStorage('video-watch-history');
    if (!value) return {};
    data = JSON.parse(value);
  } catch (error) {
    _root_helpers_logger__WEBPACK_IMPORTED_MODULE_0__.logger.error('Cannot parse video watch history from local storage/', error);
  }
  data = data || {};
  if (videoUUID) return data[videoUUID];
  return data;
}
function cleanupVideoWatch() {
  const data = getStoredVideoWatchHistory();
  if (!data) return;
  const newData = Object.keys(data).reduce((acc, videoUUID) => {
    const date = Date.parse(data[videoUUID].date);
    const diff = Math.ceil((new Date().getTime() - date) / (1000 * 3600 * 24));
    if (diff > 30) return acc;
    return {
      ...acc,
      [videoUUID]: data[videoUUID]
    };
  }, {});
  setLocalStorage('video-watch-history', JSON.stringify(newData));
}
// ---------------------------------------------------------------------------
function getPlayerSessionId() {
  const key = 'session-id';
  let sessionId = getSessionStorage(key);
  if (sessionId) return sessionId;
  sessionId = (0,_root_helpers_string__WEBPACK_IMPORTED_MODULE_2__.randomString)(32);
  setSessionStorage(key, sessionId);
  return sessionId;
}
// ---------------------------------------------------------------------------
// Private
// ---------------------------------------------------------------------------
const KEY_PREFIX = 'peertube-videojs-';
function getLocalStorage(key) {
  return _root_helpers_peertube_web_storage__WEBPACK_IMPORTED_MODULE_1__.peertubeLocalStorage.getItem(KEY_PREFIX + key);
}
function setLocalStorage(key, value) {
  _root_helpers_peertube_web_storage__WEBPACK_IMPORTED_MODULE_1__.peertubeLocalStorage.setItem(KEY_PREFIX + key, value);
}
function getSessionStorage(key) {
  return _root_helpers_peertube_web_storage__WEBPACK_IMPORTED_MODULE_1__.peertubeSessionStorage.getItem(KEY_PREFIX + key);
}
function setSessionStorage(key, value) {
  _root_helpers_peertube_web_storage__WEBPACK_IMPORTED_MODULE_1__.peertubeSessionStorage.setItem(KEY_PREFIX + key, value);
}

/***/ }),

/***/ "./src/assets/player/peertube-player.ts":
/*!**********************************************!*\
  !*** ./src/assets/player/peertube-player.ts ***!
  \**********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PeerTubePlayer: () => (/* binding */ PeerTubePlayer),
/* harmony export */   videojs: () => (/* reexport default from dynamic */ video_js__WEBPACK_IMPORTED_MODULE_29___default.a)
/* harmony export */ });
/* harmony import */ var _peertube_videojs_contextmenu__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @peertube/videojs-contextmenu */ "./node_modules/@peertube/videojs-contextmenu/dist/videojs-contextmenu.es.js");
/* harmony import */ var _shared_upnext_end_card__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./shared/upnext/end-card */ "./src/assets/player/shared/upnext/end-card.ts");
/* harmony import */ var _shared_upnext_upnext_plugin__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./shared/upnext/upnext-plugin */ "./src/assets/player/shared/upnext/upnext-plugin.ts");
/* harmony import */ var _shared_stats_stats_card__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./shared/stats/stats-card */ "./src/assets/player/shared/stats/stats-card.ts");
/* harmony import */ var _shared_stats_stats_plugin__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./shared/stats/stats-plugin */ "./src/assets/player/shared/stats/stats-plugin.ts");
/* harmony import */ var _shared_bezels_bezels_plugin__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./shared/bezels/bezels-plugin */ "./src/assets/player/shared/bezels/bezels-plugin.ts");
/* harmony import */ var _shared_peertube_peertube_plugin__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./shared/peertube/peertube-plugin */ "./src/assets/player/shared/peertube/peertube-plugin.ts");
/* harmony import */ var _shared_resolutions_peertube_resolutions_plugin__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./shared/resolutions/peertube-resolutions-plugin */ "./src/assets/player/shared/resolutions/peertube-resolutions-plugin.ts");
/* harmony import */ var _shared_control_bar_caption_toggle_button__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./shared/control-bar/caption-toggle-button */ "./src/assets/player/shared/control-bar/caption-toggle-button.ts");
/* harmony import */ var _shared_control_bar_storyboard_plugin__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./shared/control-bar/storyboard-plugin */ "./src/assets/player/shared/control-bar/storyboard-plugin.ts");
/* harmony import */ var _shared_control_bar_chapters_plugin__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./shared/control-bar/chapters-plugin */ "./src/assets/player/shared/control-bar/chapters-plugin.ts");
/* harmony import */ var _shared_control_bar_time_tooltip__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./shared/control-bar/time-tooltip */ "./src/assets/player/shared/control-bar/time-tooltip.ts");
/* harmony import */ var _shared_control_bar_next_previous_video_button__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ./shared/control-bar/next-previous-video-button */ "./src/assets/player/shared/control-bar/next-previous-video-button.ts");
/* harmony import */ var _shared_control_bar_p2p_info_button__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ./shared/control-bar/p2p-info-button */ "./src/assets/player/shared/control-bar/p2p-info-button.ts");
/* harmony import */ var _shared_control_bar_peertube_link_button__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! ./shared/control-bar/peertube-link-button */ "./src/assets/player/shared/control-bar/peertube-link-button.ts");
/* harmony import */ var _shared_control_bar_theater_button__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! ./shared/control-bar/theater-button */ "./src/assets/player/shared/control-bar/theater-button.ts");
/* harmony import */ var _shared_control_bar_peertube_live_display__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! ./shared/control-bar/peertube-live-display */ "./src/assets/player/shared/control-bar/peertube-live-display.ts");
/* harmony import */ var _shared_settings_resolution_menu_button__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! ./shared/settings/resolution-menu-button */ "./src/assets/player/shared/settings/resolution-menu-button.ts");
/* harmony import */ var _shared_settings_resolution_menu_item__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! ./shared/settings/resolution-menu-item */ "./src/assets/player/shared/settings/resolution-menu-item.ts");
/* harmony import */ var _shared_settings_settings_dialog__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! ./shared/settings/settings-dialog */ "./src/assets/player/shared/settings/settings-dialog.ts");
/* harmony import */ var _shared_settings_settings_menu_button__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! ./shared/settings/settings-menu-button */ "./src/assets/player/shared/settings/settings-menu-button.ts");
/* harmony import */ var _shared_settings_settings_menu_item__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! ./shared/settings/settings-menu-item */ "./src/assets/player/shared/settings/settings-menu-item.ts");
/* harmony import */ var _shared_settings_settings_panel__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__(/*! ./shared/settings/settings-panel */ "./src/assets/player/shared/settings/settings-panel.ts");
/* harmony import */ var _shared_settings_settings_panel_child__WEBPACK_IMPORTED_MODULE_23__ = __webpack_require__(/*! ./shared/settings/settings-panel-child */ "./src/assets/player/shared/settings/settings-panel-child.ts");
/* harmony import */ var _shared_playlist_playlist_plugin__WEBPACK_IMPORTED_MODULE_24__ = __webpack_require__(/*! ./shared/playlist/playlist-plugin */ "./src/assets/player/shared/playlist/playlist-plugin.ts");
/* harmony import */ var _shared_mobile_peertube_mobile_plugin__WEBPACK_IMPORTED_MODULE_25__ = __webpack_require__(/*! ./shared/mobile/peertube-mobile-plugin */ "./src/assets/player/shared/mobile/peertube-mobile-plugin.ts");
/* harmony import */ var _shared_mobile_peertube_mobile_buttons__WEBPACK_IMPORTED_MODULE_26__ = __webpack_require__(/*! ./shared/mobile/peertube-mobile-buttons */ "./src/assets/player/shared/mobile/peertube-mobile-buttons.ts");
/* harmony import */ var _shared_hotkeys_peertube_hotkeys_plugin__WEBPACK_IMPORTED_MODULE_27__ = __webpack_require__(/*! ./shared/hotkeys/peertube-hotkeys-plugin */ "./src/assets/player/shared/hotkeys/peertube-hotkeys-plugin.ts");
/* harmony import */ var _shared_metrics_metrics_plugin__WEBPACK_IMPORTED_MODULE_28__ = __webpack_require__(/*! ./shared/metrics/metrics-plugin */ "./src/assets/player/shared/metrics/metrics-plugin.ts");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_29__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_29___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_29__);
/* harmony import */ var _root_helpers_logger__WEBPACK_IMPORTED_MODULE_30__ = __webpack_require__(/*! @root-helpers/logger */ "./src/root-helpers/logger.ts");
/* harmony import */ var _root_helpers_utils__WEBPACK_IMPORTED_MODULE_31__ = __webpack_require__(/*! @root-helpers/utils */ "./src/root-helpers/utils.ts");
/* harmony import */ var _root_helpers_video__WEBPACK_IMPORTED_MODULE_32__ = __webpack_require__(/*! @root-helpers/video */ "./src/root-helpers/video.ts");
/* harmony import */ var _root_helpers_web_browser__WEBPACK_IMPORTED_MODULE_33__ = __webpack_require__(/*! @root-helpers/web-browser */ "./src/root-helpers/web-browser.ts");
/* harmony import */ var _peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_34__ = __webpack_require__(/*! @peertube/peertube-core-utils */ "../packages/core-utils/dist/index.js");
/* harmony import */ var _peertube_player_local_storage__WEBPACK_IMPORTED_MODULE_35__ = __webpack_require__(/*! ./peertube-player-local-storage */ "./src/assets/player/peertube-player-local-storage.ts");
/* harmony import */ var _shared_player_options_builder__WEBPACK_IMPORTED_MODULE_36__ = __webpack_require__(/*! ./shared/player-options-builder */ "./src/assets/player/shared/player-options-builder/index.ts");
/* harmony import */ var _translations_manager__WEBPACK_IMPORTED_MODULE_37__ = __webpack_require__(/*! ./translations-manager */ "./src/assets/player/translations-manager.ts");






































// Change 'Playback Rate' to 'Speed' (smaller for our settings menu)
video_js__WEBPACK_IMPORTED_MODULE_29___default().getComponent('PlaybackRateMenuButton').prototype.controlText_ = 'Speed';
const CaptionsButton = video_js__WEBPACK_IMPORTED_MODULE_29___default().getComponent('CaptionsButton');
// Change Captions to Subtitles/CC
CaptionsButton.prototype.controlText_ = 'Subtitles/CC';
// We just want to display 'Off' instead of 'captions off', keep a space so the variable == true (hacky I know)
CaptionsButton.prototype.label_ = ' ';
// TODO: remove when https://github.com/videojs/video.js/pull/7598 is merged
const PlayProgressBar = video_js__WEBPACK_IMPORTED_MODULE_29___default().getComponent('PlayProgressBar');
if (PlayProgressBar.prototype.options_.children.includes('timeTooltip') !== true) {
  PlayProgressBar.prototype.options_.children.push('timeTooltip');
}

class PeerTubePlayer {
  constructor(options) {
    this.options = options;
    this.videojsDecodeErrors = 0;
    this.moduleLoaded = {
      webVideo: false,
      p2pMediaLoader: false
    };
    this.pluginsManager = options.pluginsManager;
  }
  unload() {
    if (!this.player) return;
    this.disposeDynamicPluginsIfNeeded();
    this.player.reset();
  }
  async load(loadOptions) {
    this.currentLoadOptions = loadOptions;
    this.setPoster('');
    this.disposeDynamicPluginsIfNeeded();
    await this.lazyLoadModulesIfNeeded();
    await this.buildPlayerIfNeeded();
    if (this.currentLoadOptions.mode === 'p2p-media-loader') {
      await this.loadP2PMediaLoader();
    } else {
      this.loadWebVideo();
    }
    this.loadDynamicPlugins();
    if (this.options.controlBar === false) this.player.controlBar.hide();else this.player.controlBar.show();
    this.player.autoplay(this.getAutoPlayValue(this.currentLoadOptions.autoplay));
    if (!this.player.autoplay()) {
      this.setPoster(loadOptions.poster);
    }
    this.player.trigger('video-change');
  }
  getPlayer() {
    return this.player;
  }
  destroy() {
    if (this.player) this.player.dispose();
  }
  setPoster(url) {
    var _this$player;
    // Use HTML video element to display poster
    if (!this.player) {
      this.options.playerElement().poster = url;
      return;
    }
    // Prefer using player poster API
    (_this$player = this.player) === null || _this$player === void 0 || _this$player.poster(url);
    this.options.playerElement().poster = '';
  }
  enable() {
    if (!this.player) return;
    this.player.el().style.pointerEvents = 'auto';
  }
  disable() {
    if (!this.player) return;
    if (this.player.isFullscreen()) {
      this.player.exitFullscreen();
    }
    // Disable player
    this.player.hasStarted(false);
    this.player.removeClass('vjs-has-autoplay');
    this.player.bigPlayButton.hide();
    this.player.el().style.pointerEvents = 'none';
  }
  async loadP2PMediaLoader() {
    const hlsOptionsBuilder = new _shared_player_options_builder__WEBPACK_IMPORTED_MODULE_36__.HLSOptionsBuilder({
      ...(0,_peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_34__.pick)(this.options, ['pluginsManager', 'serverUrl', 'authorizationHeader']),
      ...(0,_peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_34__.pick)(this.currentLoadOptions, ['videoPassword', 'requiresUserAuth', 'videoFileToken', 'requiresPassword', 'isLive', 'p2pEnabled', 'liveOptions', 'hls'])
    }, this.p2pMediaLoaderModule);
    const {
      hlsjs,
      p2pMediaLoader
    } = await hlsOptionsBuilder.getPluginOptions();
    this.player.hlsjs(hlsjs);
    this.player.p2pMediaLoader(p2pMediaLoader);
  }
  loadWebVideo() {
    const webVideoOptionsBuilder = new _shared_player_options_builder__WEBPACK_IMPORTED_MODULE_36__.WebVideoOptionsBuilder((0,_peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_34__.pick)(this.currentLoadOptions, ['videoFileToken', 'webVideo', 'hls']));
    this.player.webVideo(webVideoOptionsBuilder.getPluginOptions());
  }
  async buildPlayerIfNeeded() {
    if (this.player) return;
    await _translations_manager__WEBPACK_IMPORTED_MODULE_37__.TranslationsManager.loadLocaleInVideoJS(this.options.serverUrl, this.options.language, (video_js__WEBPACK_IMPORTED_MODULE_29___default()));
    const videojsOptions = await this.pluginsManager.runHook('filter:internal.player.videojs.options.result', this.getVideojsOptions());
    this.player = video_js__WEBPACK_IMPORTED_MODULE_29___default()(this.options.playerElement(), videojsOptions);
    this.player.ready(() => {
      if (!isNaN(+this.options.playbackRate)) {
        this.player.playbackRate(+this.options.playbackRate);
      }
      let alreadyFallback = false;
      const handleError = () => {
        if (alreadyFallback) return;
        alreadyFallback = true;
        if (this.currentLoadOptions.mode === 'p2p-media-loader') {
          this.tryToRecoverHLSError(this.player.error());
        } else {
          this.maybeFallbackToWebVideo();
        }
      };
      this.player.on('video-change', () => alreadyFallback = false);
      this.player.on('error', () => handleError());
      this.player.on('network-info', (_, data) => {
        if (data.source !== 'p2p-media-loader' || isNaN(data.bandwidthEstimate)) return;
        (0,_peertube_player_local_storage__WEBPACK_IMPORTED_MODULE_35__.saveAverageBandwidth)(data.bandwidthEstimate);
      });
      this.player.contextmenuUI(this.getContextMenuOptions());
      this.displayNotificationWhenOffline();
    });
  }
  disposeDynamicPluginsIfNeeded() {
    if (!this.player) return;
    if (this.player.usingPlugin('peertubeMobile')) this.player.peertubeMobile().dispose();
    if (this.player.usingPlugin('peerTubeHotkeysPlugin')) this.player.peerTubeHotkeysPlugin().dispose();
    if (this.player.usingPlugin('playlist')) this.player.playlist().dispose();
    if (this.player.usingPlugin('bezels')) this.player.bezels().dispose();
    if (this.player.usingPlugin('upnext')) this.player.upnext().dispose();
    if (this.player.usingPlugin('stats')) this.player.stats().dispose();
    if (this.player.usingPlugin('storyboard')) this.player.storyboard().dispose();
    if (this.player.usingPlugin('chapters')) this.player.chapters().dispose();
    if (this.player.usingPlugin('peertubeDock')) this.player.peertubeDock().dispose();
    if (this.player.usingPlugin('p2pMediaLoader')) this.player.p2pMediaLoader().dispose();
    if (this.player.usingPlugin('hlsjs')) this.player.hlsjs().dispose();
    if (this.player.usingPlugin('webVideo')) this.player.webVideo().dispose();
  }
  loadDynamicPlugins() {
    if ((0,_root_helpers_web_browser__WEBPACK_IMPORTED_MODULE_33__.isMobile)()) this.player.peertubeMobile();
    this.player.bezels();
    this.player.stats({
      videoUUID: this.currentLoadOptions.videoUUID,
      videoIsLive: this.currentLoadOptions.isLive,
      mode: this.currentLoadOptions.mode,
      p2pEnabled: this.currentLoadOptions.p2pEnabled
    });
    if (this.options.enableHotkeys === true) {
      this.player.peerTubeHotkeysPlugin({
        isLive: this.currentLoadOptions.isLive
      });
    }
    if (this.currentLoadOptions.playlist) {
      this.player.playlist(this.currentLoadOptions.playlist);
    }
    if (this.currentLoadOptions.upnext) {
      this.player.upnext({
        timeout: this.currentLoadOptions.upnext.timeout,
        getTitle: () => this.currentLoadOptions.nextVideo.getVideoTitle(),
        next: () => this.currentLoadOptions.nextVideo.handler(),
        isDisplayed: () => this.currentLoadOptions.nextVideo.enabled && this.currentLoadOptions.upnext.isEnabled(),
        isSuspended: () => this.currentLoadOptions.upnext.isSuspended(this.player)
      });
    }
    if (this.currentLoadOptions.storyboard) {
      this.player.storyboard(this.currentLoadOptions.storyboard);
    }
    if (this.currentLoadOptions.videoChapters) {
      this.player.chapters({
        chapters: this.currentLoadOptions.videoChapters
      });
    }
    if (this.currentLoadOptions.dock) {
      this.player.peertubeDock(this.currentLoadOptions.dock);
    }
  }
  async lazyLoadModulesIfNeeded() {
    if (this.currentLoadOptions.mode === 'web-video' && this.moduleLoaded.webVideo !== true) {
      await __webpack_require__.e(/*! import() */ "src_assets_player_shared_web-video_web-video-plugin_ts").then(__webpack_require__.bind(__webpack_require__, /*! ./shared/web-video/web-video-plugin */ "./src/assets/player/shared/web-video/web-video-plugin.ts"));
    }
    if (this.currentLoadOptions.mode === 'p2p-media-loader' && this.moduleLoaded.p2pMediaLoader !== true) {
      const [p2pMediaLoaderModule] = await Promise.all([Promise.all(/*! import() */[__webpack_require__.e("vendors-node_modules_peertube_p2p-media-loader-hlsjs_dist_index_js"), __webpack_require__.e("_2d84-_5a06-_ed7a-_5c78-_ed1b-_d17e-_c33b")]).then(__webpack_require__.t.bind(__webpack_require__, /*! @peertube/p2p-media-loader-hlsjs */ "./node_modules/@peertube/p2p-media-loader-hlsjs/dist/index.js", 23)), Promise.all(/*! import() */[__webpack_require__.e("vendors-node_modules_hls_js_dist_hls_light_js"), __webpack_require__.e("src_assets_player_shared_p2p-media-loader_hls-plugin_ts")]).then(__webpack_require__.bind(__webpack_require__, /*! ./shared/p2p-media-loader/hls-plugin */ "./src/assets/player/shared/p2p-media-loader/hls-plugin.ts")), Promise.all(/*! import() */[__webpack_require__.e("vendors-node_modules_hls_js_dist_hls_light_js"), __webpack_require__.e("vendors-node_modules_peertube_p2p-media-loader-hlsjs_dist_index_js"), __webpack_require__.e("src_assets_player_shared_p2p-media-loader_p2p-media-loader-plugin_ts")]).then(__webpack_require__.bind(__webpack_require__, /*! ./shared/p2p-media-loader/p2p-media-loader-plugin */ "./src/assets/player/shared/p2p-media-loader/p2p-media-loader-plugin.ts"))]);
      this.p2pMediaLoaderModule = p2pMediaLoaderModule;
    }
  }
  async tryToRecoverHLSError(err) {
    if (err.code === MediaError.MEDIA_ERR_DECODE) {
      // Display a notification to user
      if (this.videojsDecodeErrors === 0) {
        this.options.errorNotifier(this.player.localize('The video failed to play, will try to fast forward.'));
      }
      if (this.videojsDecodeErrors === 20) {
        this.maybeFallbackToWebVideo();
        return;
      }
      _root_helpers_logger__WEBPACK_IMPORTED_MODULE_30__.logger.info('Fast forwarding HLS to recover from an error.');
      this.videojsDecodeErrors++;
      await this.load({
        ...this.currentLoadOptions,
        mode: 'p2p-media-loader',
        startTime: this.player.currentTime() + 2,
        autoplay: true
      });
    } else {
      this.maybeFallbackToWebVideo();
    }
  }
  async maybeFallbackToWebVideo() {
    if (this.currentLoadOptions.mode === 'web-video') {
      this.player.peertube().displayFatalError();
      return;
    }
    _root_helpers_logger__WEBPACK_IMPORTED_MODULE_30__.logger.info('Fallback to web-video.');
    await this.load({
      ...this.currentLoadOptions,
      mode: 'web-video',
      startTime: this.player.currentTime(),
      autoplay: true
    });
  }
  getVideojsOptions() {
    const html5 = {
      preloadTextTracks: false
    };
    const plugins = {
      peertube: {
        hasAutoplay: () => this.getAutoPlayValue(this.currentLoadOptions.autoplay),
        videoViewUrl: () => this.currentLoadOptions.videoViewUrl,
        videoViewIntervalMs: this.options.videoViewIntervalMs,
        authorizationHeader: this.options.authorizationHeader,
        videoDuration: () => this.currentLoadOptions.duration,
        startTime: () => this.currentLoadOptions.startTime,
        stopTime: () => this.currentLoadOptions.stopTime,
        videoCaptions: () => this.currentLoadOptions.videoCaptions,
        isLive: () => this.currentLoadOptions.isLive,
        videoUUID: () => this.currentLoadOptions.videoUUID,
        subtitle: () => this.currentLoadOptions.subtitle,
        videoRatio: () => this.currentLoadOptions.videoRatio,
        poster: () => this.currentLoadOptions.poster,
        autoPlayerRatio: this.options.autoPlayerRatio
      },
      metrics: {
        mode: () => this.currentLoadOptions.mode,
        metricsUrl: () => this.options.metricsUrl,
        metricsInterval: () => this.options.metricsInterval,
        videoUUID: () => this.currentLoadOptions.videoUUID
      }
    };
    const controlBarOptionsBuilder = new _shared_player_options_builder__WEBPACK_IMPORTED_MODULE_36__.ControlBarOptionsBuilder({
      ...this.options,
      videoShortUUID: () => this.currentLoadOptions.videoShortUUID,
      p2pEnabled: () => this.currentLoadOptions.p2pEnabled,
      nextVideo: () => this.currentLoadOptions.nextVideo,
      previousVideo: () => this.currentLoadOptions.previousVideo
    });
    const videojsOptions = {
      html5,
      // We don't use text track settings for now
      textTrackSettings: false,
      controls: this.options.controls !== undefined ? this.options.controls : true,
      loop: this.options.loop !== undefined ? this.options.loop : false,
      muted: this.options.muted !== undefined ? this.options.muted : undefined,
      autoplay: this.getAutoPlayValue(this.currentLoadOptions.autoplay),
      poster: this.currentLoadOptions.poster,
      inactivityTimeout: this.options.inactivityTimeout,
      playbackRates: [0.5, 0.75, 1, 1.25, 1.5, 1.75, 2],
      plugins,
      controlBar: {
        children: controlBarOptionsBuilder.getChildrenOptions() // FIXME: typings
      },
      language: this.options.language && !(0,_peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_34__.isDefaultLocale)(this.options.language) ? this.options.language : undefined
    };
    return videojsOptions;
  }
  getAutoPlayValue(autoplay) {
    if (autoplay !== true) return false;
    return this.currentLoadOptions.forceAutoplay ? 'any' : 'play';
  }
  displayNotificationWhenOffline() {
    const offlineNotificationElem = document.createElement('div');
    offlineNotificationElem.classList.add('vjs-peertube-offline-notification');
    offlineNotificationElem.innerText = this.player.localize('You seem to be offline and the video may not work');
    let offlineNotificationElemAdded = false;
    const handleOnline = () => {
      if (!offlineNotificationElemAdded) return;
      this.player.el().removeChild(offlineNotificationElem);
      offlineNotificationElemAdded = false;
      _root_helpers_logger__WEBPACK_IMPORTED_MODULE_30__.logger.info('The browser is online');
    };
    const handleOffline = () => {
      if (offlineNotificationElemAdded) return;
      this.player.el().appendChild(offlineNotificationElem);
      offlineNotificationElemAdded = true;
      _root_helpers_logger__WEBPACK_IMPORTED_MODULE_30__.logger.info('The browser is offline');
    };
    window.addEventListener('online', handleOnline);
    window.addEventListener('offline', handleOffline);
    this.player.on('dispose', () => {
      window.removeEventListener('online', handleOnline);
      window.removeEventListener('offline', handleOffline);
    });
  }
  getContextMenuOptions() {
    const content = () => {
      const self = this;
      const player = this.player;
      const shortUUID = self.currentLoadOptions.videoShortUUID;
      const isLoopEnabled = player.options_['loop'];
      const items = [{
        icon: 'repeat',
        label: player.localize('Play in loop') + (isLoopEnabled ? '<span class="vjs-icon-tick-white"></span>' : ''),
        listener: function () {
          player.options_['loop'] = !isLoopEnabled;
        }
      }, {
        label: player.localize('Copy the video URL'),
        listener: function () {
          (0,_root_helpers_utils__WEBPACK_IMPORTED_MODULE_31__.copyToClipboard)((0,_peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_34__.buildVideoLink)({
            shortUUID
          }));
        }
      }, {
        label: player.localize('Copy the video URL at the current time'),
        listener: function () {
          const url = (0,_peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_34__.buildVideoLink)({
            shortUUID
          });
          (0,_root_helpers_utils__WEBPACK_IMPORTED_MODULE_31__.copyToClipboard)((0,_peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_34__.decorateVideoLink)({
            url,
            startTime: player.currentTime()
          }));
        }
      }, {
        icon: 'code',
        label: player.localize('Copy embed code'),
        listener: () => {
          (0,_root_helpers_utils__WEBPACK_IMPORTED_MODULE_31__.copyToClipboard)((0,_root_helpers_video__WEBPACK_IMPORTED_MODULE_32__.buildVideoOrPlaylistEmbed)({
            embedUrl: self.currentLoadOptions.embedUrl,
            embedTitle: self.currentLoadOptions.embedTitle
          }));
        }
      }];
      items.push({
        icon: 'info',
        label: player.localize('Stats for nerds'),
        listener: () => {
          player.stats().show();
        }
      });
      return items.map(i => ({
        ...i,
        label: "<span class=\"vjs-icon-".concat(i.icon || 'link-2', "\"></span>") + i.label
      }));
    };
    return {
      content
    };
  }
}

/***/ }),

/***/ "./src/assets/player/shared/bezels/bezels-plugin.ts":
/*!**********************************************************!*\
  !*** ./src/assets/player/shared/bezels/bezels-plugin.ts ***!
  \**********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   BezelsPlugin: () => (/* binding */ BezelsPlugin)
/* harmony export */ });
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _pause_bezel__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./pause-bezel */ "./src/assets/player/shared/bezels/pause-bezel.ts");


const Plugin = video_js__WEBPACK_IMPORTED_MODULE_0___default().getPlugin('plugin');
class BezelsPlugin extends Plugin {
  constructor(player, options) {
    super(player);
    this.player.ready(() => {
      player.addClass('vjs-bezels');
    });
    const component = new _pause_bezel__WEBPACK_IMPORTED_MODULE_1__.PauseBezel(player, options);
    player.addChild(component);
    this.on('dispose', () => player.removeChild(component));
  }
}
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerPlugin('bezels', BezelsPlugin);


/***/ }),

/***/ "./src/assets/player/shared/bezels/pause-bezel.ts":
/*!********************************************************!*\
  !*** ./src/assets/player/shared/bezels/pause-bezel.ts ***!
  \********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PauseBezel: () => (/* binding */ PauseBezel)
/* harmony export */ });
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _root_helpers_web_browser__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @root-helpers/web-browser */ "./src/root-helpers/web-browser.ts");


function getPauseBezel() {
  return "\n  <div class=\"vjs-bezels-pause\">\n    <div class=\"vjs-bezel\" role=\"status\" aria-label=\"Pause\">\n      <div class=\"vjs-bezel-icon\">\n        <svg height=\"100%\" version=\"1.1\" viewBox=\"0 0 36 36\" width=\"100%\">\n          <use class=\"vjs-svg-shadow\" xlink:href=\"#vjs-id-1\"></use>\n          <path class=\"vjs-svg-fill\" d=\"M 12,26 16,26 16,10 12,10 z M 21,26 25,26 25,10 21,10 z\" id=\"vjs-id-1\"></path>\n        </svg>\n      </div>\n    </div>\n  </div>\n  ";
}
function getPlayBezel() {
  return "\n  <div class=\"vjs-bezels-play\">\n    <div class=\"vjs-bezel\" role=\"status\" aria-label=\"Play\">\n      <div class=\"vjs-bezel-icon\">\n        <svg height=\"100%\" version=\"1.1\" viewBox=\"0 0 36 36\" width=\"100%\">\n          <use class=\"vjs-svg-shadow\" xlink:href=\"#vjs-id-2\"></use>\n          <path class=\"vjs-svg-fill\" d=\"M 12,26 18.5,22 18.5,14 12,10 z M 18.5,22 25,18 25,18 18.5,14 z\" id=\"ytp-id-2\"></path>\n        </svg>\n      </div>\n    </div>\n  </div>\n  ";
}
const Component = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('Component');
class PauseBezel extends Component {
  constructor(player, options) {
    super(player, options);
    this.firstPlayDone = false;
    this.paused = false;
    // Hide bezels on mobile since we already have our mobile overlay
    if ((0,_root_helpers_web_browser__WEBPACK_IMPORTED_MODULE_1__.isMobile)()) return;
    this.playerPauseHandler = () => {
      if (player.seeking()) return;
      this.paused = true;
      if (player.ended()) return;
      this.container.innerHTML = getPauseBezel();
      this.showBezel();
    };
    this.playerPlayHandler = () => {
      if (player.seeking() || !this.firstPlayDone || !this.paused) {
        this.firstPlayDone = true;
        return;
      }
      this.paused = false;
      this.firstPlayDone = true;
      this.container.innerHTML = getPlayBezel();
      this.showBezel();
    };
    this.videoChangeHandler = () => {
      this.firstPlayDone = false;
    };
    player.on('video-change', () => this.videoChangeHandler);
    player.on('pause', this.playerPauseHandler);
    player.on('play', this.playerPlayHandler);
  }
  dispose() {
    if (this.playerPauseHandler) this.player().off('pause', this.playerPauseHandler);
    if (this.playerPlayHandler) this.player().off('play', this.playerPlayHandler);
    if (this.videoChangeHandler) this.player().off('video-change', this.videoChangeHandler);
    super.dispose();
  }
  createEl() {
    this.container = super.createEl('div', {
      className: 'vjs-bezels-content'
    });
    this.container.style.display = 'none';
    return this.container;
  }
  showBezel() {
    this.container.style.display = 'inherit';
    setTimeout(() => {
      this.container.style.display = 'none';
    }, 500); // matching the animation duration
  }
}
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerComponent('PauseBezel', PauseBezel);

/***/ }),

/***/ "./src/assets/player/shared/common/index.ts":
/*!**************************************************!*\
  !*** ./src/assets/player/shared/common/index.ts ***!
  \**************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   bytes: () => (/* reexport safe */ _utils__WEBPACK_IMPORTED_MODULE_0__.bytes),
/* harmony export */   getRtcConfig: () => (/* reexport safe */ _utils__WEBPACK_IMPORTED_MODULE_0__.getRtcConfig),
/* harmony export */   isSameOrigin: () => (/* reexport safe */ _utils__WEBPACK_IMPORTED_MODULE_0__.isSameOrigin),
/* harmony export */   toTitleCase: () => (/* reexport safe */ _utils__WEBPACK_IMPORTED_MODULE_0__.toTitleCase)
/* harmony export */ });
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./utils */ "./src/assets/player/shared/common/utils.ts");


/***/ }),

/***/ "./src/assets/player/shared/common/utils.ts":
/*!**************************************************!*\
  !*** ./src/assets/player/shared/common/utils.ts ***!
  \**************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   bytes: () => (/* binding */ bytes),
/* harmony export */   getRtcConfig: () => (/* binding */ getRtcConfig),
/* harmony export */   isSameOrigin: () => (/* binding */ isSameOrigin),
/* harmony export */   toTitleCase: () => (/* binding */ toTitleCase)
/* harmony export */ });
function toTitleCase(str) {
  return str.charAt(0).toUpperCase() + str.slice(1);
}
const dictionaryBytes = [{
  max: 1024,
  type: 'B',
  decimals: 0
}, {
  max: 1048576,
  type: 'KB',
  decimals: 0
}, {
  max: 1073741824,
  type: 'MB',
  decimals: 0
}, {
  max: 1.0995116e12,
  type: 'GB',
  decimals: 1
}];
function bytes(value) {
  const format = dictionaryBytes.find(d => value < d.max) || dictionaryBytes[dictionaryBytes.length - 1];
  const calc = (value / (format.max / 1024)).toFixed(format.decimals);
  return [calc, format.type];
}
function getRtcConfig() {
  return {
    iceServers: [{
      urls: 'stun:stun.stunprotocol.org'
    }, {
      urls: 'stun:stun.framasoft.org'
    }]
  };
}
function isSameOrigin(current, target) {
  return new URL(current).origin === new URL(target).origin;
}

/***/ }),

/***/ "./src/assets/player/shared/control-bar/caption-toggle-button.ts":
/*!***********************************************************************!*\
  !*** ./src/assets/player/shared/control-bar/caption-toggle-button.ts ***!
  \***********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _peertube_player_local_storage__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../../peertube-player-local-storage */ "./src/assets/player/peertube-player-local-storage.ts");


const Button = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('Button');
class CaptionToggleButton extends Button {
  constructor(player, options) {
    super(player, options);
    player.on('texttrackchange', () => this.update());
  }
  buildCSSClass() {
    // Inherits vjs-captions-button for the icon
    return "vjs-caption-toggle-control vjs-captions-button ".concat(super.buildCSSClass());
  }
  handleClick(event) {
    var _this$getCaptionToEna;
    super.handleClick(event);
    const toEnable = this.getShowing() ? undefined : (_this$getCaptionToEna = this.getCaptionToEnable()) === null || _this$getCaptionToEna === void 0 ? void 0 : _this$getCaptionToEna.id;
    for (const track of this.player_.textTracks().tracks_) {
      if (toEnable && track.id === toEnable) track.mode = 'showing';else track.mode = 'disabled';
    }
  }
  update() {
    var _this$getCaptionToEna2;
    if (this.getShowing()) {
      this.controlText('Disable subtitles');
      this.addClass('enabled');
      return;
    }
    this.controlText(this.player_.localize('Enable {1} subtitle', [(_this$getCaptionToEna2 = this.getCaptionToEnable()) === null || _this$getCaptionToEna2 === void 0 ? void 0 : _this$getCaptionToEna2.label]));
    this.removeClass('enabled');
  }
  getShowing() {
    return this.listCaptions().find(t => t.mode === 'showing');
  }
  getCaptionToEnable() {
    var _this$listCaptions$;
    const captionToEnable = (0,_peertube_player_local_storage__WEBPACK_IMPORTED_MODULE_1__.getStoredPreferredSubtitle)() || ((_this$listCaptions$ = this.listCaptions()[0]) === null || _this$listCaptions$ === void 0 ? void 0 : _this$listCaptions$.id);
    const captions = this.listCaptions();
    return captions.find(t => t.id === captionToEnable) || captions[0];
  }
  listCaptions() {
    return this.player_.textTracks().tracks_.filter(t => t.kind === 'captions');
  }
}
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerComponent('CaptionToggleButton', CaptionToggleButton);

/***/ }),

/***/ "./src/assets/player/shared/control-bar/chapters-plugin.ts":
/*!*****************************************************************!*\
  !*** ./src/assets/player/shared/control-bar/chapters-plugin.ts ***!
  \*****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ChaptersPlugin: () => (/* binding */ ChaptersPlugin)
/* harmony export */ });
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _progress_bar_marker_component__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./progress-bar-marker-component */ "./src/assets/player/shared/control-bar/progress-bar-marker-component.ts");


const Plugin = video_js__WEBPACK_IMPORTED_MODULE_0___default().getPlugin('plugin');
class ChaptersPlugin extends Plugin {
  constructor(player, options) {
    super(player, options);
    this.chapters = [];
    this.markers = [];
    this.chapters = options.chapters;
    this.player.ready(() => {
      player.addClass('vjs-chapters');
      for (const chapter of this.chapters) {
        if (chapter.timecode === 0) continue;
        const marker = new _progress_bar_marker_component__WEBPACK_IMPORTED_MODULE_1__.ProgressBarMarkerComponent(player, {
          timecode: chapter.timecode
        });
        this.markers.push(marker);
        this.getSeekBar().addChild(marker);
      }
    });
  }
  dispose() {
    for (const marker of this.markers) {
      this.getSeekBar().removeChild(marker);
    }
    super.dispose();
  }
  getChapter(timecode) {
    if (this.chapters.length !== 0) {
      for (let i = this.chapters.length - 1; i >= 0; i--) {
        const chapter = this.chapters[i];
        if (chapter.timecode <= timecode) {
          this.player.addClass('has-chapter');
          return chapter.title;
        }
      }
    }
    this.player.removeClass('has-chapter');
    return '';
  }
  getSeekBar() {
    return this.player.getDescendant('ControlBar', 'ProgressControl', 'SeekBar');
  }
}
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerPlugin('chapters', ChaptersPlugin);


/***/ }),

/***/ "./src/assets/player/shared/control-bar/next-previous-video-button.ts":
/*!****************************************************************************!*\
  !*** ./src/assets/player/shared/control-bar/next-previous-video-button.ts ***!
  \****************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);

const Button = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('Button');
class NextPreviousVideoButton extends Button {
  constructor(player, options) {
    super(player, options);
    this.player().on('video-change', () => {
      this.updateDisabled();
      this.updateShowing();
    });
    this.updateDisabled();
    this.updateShowing();
  }
  createEl() {
    const type = this.options_.type;
    const button = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('button', {
      className: 'vjs-' + type + '-video'
    });
    const nextIcon = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('span', {
      className: 'icon icon-' + type
    });
    button.appendChild(nextIcon);
    if (type === 'next') {
      button.title = this.player_.localize('Next video');
    } else {
      button.title = this.player_.localize('Previous video');
    }
    return button;
  }
  handleClick() {
    this.options_.handler();
  }
  updateDisabled() {
    const disabled = this.options_.isDisabled();
    if (disabled) this.addClass('vjs-disabled');else this.removeClass('vjs-disabled');
  }
  updateShowing() {
    if (this.options_.isDisplayed()) this.show();else this.hide();
  }
}
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerComponent('NextVideoButton', NextPreviousVideoButton);
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerComponent('PreviousVideoButton', NextPreviousVideoButton);

/***/ }),

/***/ "./src/assets/player/shared/control-bar/p2p-info-button.ts":
/*!*****************************************************************!*\
  !*** ./src/assets/player/shared/control-bar/p2p-info-button.ts ***!
  \*****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _common__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../common */ "./src/assets/player/shared/common/index.ts");


const Button = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('Button');
class P2PInfoButton extends Button {
  createEl() {
    const div = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('div', {
      className: 'vjs-peertube'
    });
    const subDivP2P = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('div', {
      className: 'vjs-peertube-hidden' // Hide the stats before we get the info
    });
    div.appendChild(subDivP2P);
    const downloadIcon = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('span', {
      className: 'icon icon-download'
    });
    subDivP2P.appendChild(downloadIcon);
    const downloadSpeedText = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('span', {
      className: 'download-speed-text'
    });
    const downloadSpeedNumber = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('span', {
      className: 'download-speed-number'
    });
    const downloadSpeedUnit = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('span');
    downloadSpeedText.appendChild(downloadSpeedNumber);
    downloadSpeedText.appendChild(downloadSpeedUnit);
    subDivP2P.appendChild(downloadSpeedText);
    const uploadIcon = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('span', {
      className: 'icon icon-upload'
    });
    subDivP2P.appendChild(uploadIcon);
    const uploadSpeedText = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('span', {
      className: 'upload-speed-text'
    });
    const uploadSpeedNumber = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('span', {
      className: 'upload-speed-number'
    });
    const uploadSpeedUnit = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('span');
    uploadSpeedText.appendChild(uploadSpeedNumber);
    uploadSpeedText.appendChild(uploadSpeedUnit);
    subDivP2P.appendChild(uploadSpeedText);
    const peersText = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('span', {
      className: 'peers-text'
    });
    const peersNumber = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('span', {
      className: 'peers-number'
    });
    subDivP2P.appendChild(peersNumber);
    subDivP2P.appendChild(peersText);
    const subDivHttp = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('div', {
      className: 'vjs-peertube-hidden'
    });
    const subDivHttpText = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('span', {
      className: 'http-fallback'
    });
    subDivHttp.appendChild(subDivHttpText);
    div.appendChild(subDivHttp);
    this.player_.on('network-info', (_event, data) => {
      if (!data.p2p) return;
      subDivP2P.className = 'vjs-peertube-displayed';
      subDivHttp.className = 'vjs-peertube-hidden';
      const p2pStats = data.p2p;
      const httpStats = data.http;
      const downloadSpeed = (0,_common__WEBPACK_IMPORTED_MODULE_1__.bytes)(p2pStats.downloadSpeed + httpStats.downloadSpeed);
      const uploadSpeed = (0,_common__WEBPACK_IMPORTED_MODULE_1__.bytes)(p2pStats.uploadSpeed);
      const totalDownloaded = (0,_common__WEBPACK_IMPORTED_MODULE_1__.bytes)(p2pStats.downloaded + httpStats.downloaded);
      const totalUploaded = (0,_common__WEBPACK_IMPORTED_MODULE_1__.bytes)(p2pStats.uploaded);
      const numPeers = p2pStats.peersWithWebSeed;
      subDivP2P.title = this.player().localize('Total downloaded: ') + totalDownloaded.join(' ') + '\n';
      if (data.source === 'p2p-media-loader') {
        const downloadedFromServer = (0,_common__WEBPACK_IMPORTED_MODULE_1__.bytes)(httpStats.downloaded).join(' ');
        const downloadedFromPeers = (0,_common__WEBPACK_IMPORTED_MODULE_1__.bytes)(p2pStats.downloaded).join(' ');
        subDivP2P.title += ' * ' + this.player().localize('From servers: ') + downloadedFromServer + '\n' + ' * ' + this.player().localize('From peers: ') + downloadedFromPeers + '\n';
      }
      subDivP2P.title += this.player().localize('Total uploaded: ') + totalUploaded.join(' ');
      downloadSpeedNumber.textContent = downloadSpeed[0];
      downloadSpeedUnit.textContent = ' ' + downloadSpeed[1];
      uploadSpeedNumber.textContent = uploadSpeed[0];
      uploadSpeedUnit.textContent = ' ' + uploadSpeed[1];
      peersNumber.textContent = numPeers.toString();
      peersText.textContent = ' ' + (numPeers > 1 ? this.player().localize('peers') : this.player_.localize('peer'));
      subDivHttp.className = 'vjs-peertube-hidden';
      subDivP2P.className = 'vjs-peertube-displayed';
    });
    this.player_.on('network-info', (_event, data) => {
      if (data.p2p) return;
      if (data.source === 'web-video') subDivHttpText.textContent = 'HTTP';else if (data.source === 'p2p-media-loader') subDivHttpText.textContent = 'HLS';
      // We are in HTTP mode
      subDivHttp.className = 'vjs-peertube-displayed';
      subDivP2P.className = 'vjs-peertube-hidden';
      subDivHttp.title = this.player().localize('Total downloaded: ') + (0,_common__WEBPACK_IMPORTED_MODULE_1__.bytes)(data.http.downloaded).join(' ');
    });
    this.player_.on('video-change', () => {
      subDivP2P.className = 'vjs-peertube-hidden';
      subDivHttp.className = 'vjs-peertube-hidden';
    });
    return div;
  }
}
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerComponent('P2PInfoButton', P2PInfoButton);

/***/ }),

/***/ "./src/assets/player/shared/control-bar/peertube-link-button.ts":
/*!**********************************************************************!*\
  !*** ./src/assets/player/shared/control-bar/peertube-link-button.ts ***!
  \**********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @peertube/peertube-core-utils */ "../packages/core-utils/dist/index.js");


const Component = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('Component');
class PeerTubeLinkButton extends Component {
  constructor(player, options) {
    super(player, options);
    this.updateShowing();
    this.player().on('video-change', () => this.updateShowing());
  }
  dispose() {
    if (this.el()) return;
    this.el().removeEventListener('mouseenter', this.mouseEnterHandler);
    this.el().removeEventListener('click', this.clickHandler);
    super.dispose();
  }
  createEl() {
    const el = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('a', {
      href: this.buildLink(),
      innerText: this.options_.instanceName,
      title: this.player().localize('Video page (new window)'),
      className: 'vjs-peertube-link',
      target: '_blank'
    });
    this.mouseEnterHandler = () => this.updateHref();
    this.clickHandler = () => this.player().pause();
    el.addEventListener('mouseenter', this.mouseEnterHandler);
    el.addEventListener('click', this.clickHandler);
    return el;
  }
  updateShowing() {
    if (this.options_.isDisplayed()) this.show();else this.hide();
  }
  updateHref() {
    this.el().setAttribute('href', this.buildLink());
  }
  buildLink() {
    const url = (0,_peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_1__.buildVideoLink)({
      shortUUID: this.options_.shortUUID()
    });
    return (0,_peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_1__.decorateVideoLink)({
      url,
      startTime: this.player().currentTime()
    });
  }
}
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerComponent('PeerTubeLinkButton', PeerTubeLinkButton);

/***/ }),

/***/ "./src/assets/player/shared/control-bar/peertube-live-display.ts":
/*!***********************************************************************!*\
  !*** ./src/assets/player/shared/control-bar/peertube-live-display.ts ***!
  \***********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);

const ClickableComponent = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('ClickableComponent');
class PeerTubeLiveDisplay extends ClickableComponent {
  constructor(player, options) {
    super(player, options);
    this.interval = this.setInterval(() => this.updateClass(), 1000);
    this.updateSync(true);
  }
  dispose() {
    if (this.interval) {
      this.clearInterval(this.interval);
      this.interval = undefined;
    }
    this.contentEl_ = null;
    super.dispose();
  }
  createEl() {
    const el = super.createEl('div', {
      className: 'vjs-pt-live-control vjs-control'
    });
    this.contentEl_ = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('div', {
      className: 'vjs-live-display'
    }, {
      'aria-live': 'off'
    });
    this.contentEl_.appendChild(video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('span', {
      className: 'vjs-control-text',
      textContent: "".concat(this.localize('Stream Type'), "\xA0")
    }));
    this.contentEl_.appendChild(document.createTextNode(this.localize('LIVE')));
    el.appendChild(this.contentEl_);
    return el;
  }
  handleClick() {
    const hlsjs = this.getHLSJS();
    if (!hlsjs) return;
    this.player().currentTime(hlsjs.liveSyncPosition);
    this.player().play();
    this.updateSync(true);
  }
  updateClass() {
    const hlsjs = this.getHLSJS();
    if (!hlsjs) return;
    // Not loaded yet
    if (this.player().currentTime() === 0) return;
    const isSync = Math.abs(this.player().currentTime() - hlsjs.liveSyncPosition) < 10;
    this.updateSync(isSync);
  }
  updateSync(isSync) {
    if (isSync) {
      this.addClass('synced-with-live-edge');
      this.removeAttribute('title');
      this.disable();
    } else {
      this.removeClass('synced-with-live-edge');
      this.setAttribute('title', this.localize('Go back to the live'));
      this.enable();
    }
  }
  getHLSJS() {
    var _this$player;
    if (!((_this$player = this.player()) !== null && _this$player !== void 0 && _this$player.usingPlugin('p2pMediaLoader'))) return;
    return this.player().p2pMediaLoader().getHLSJS();
  }
}
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerComponent('PeerTubeLiveDisplay', PeerTubeLiveDisplay);

/***/ }),

/***/ "./src/assets/player/shared/control-bar/progress-bar-marker-component.ts":
/*!*******************************************************************************!*\
  !*** ./src/assets/player/shared/control-bar/progress-bar-marker-component.ts ***!
  \*******************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ProgressBarMarkerComponent: () => (/* binding */ ProgressBarMarkerComponent)
/* harmony export */ });
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);

const Component = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('Component');
class ProgressBarMarkerComponent extends Component {
  // eslint-disable-next-line @typescript-eslint/no-useless-constructor
  constructor(player, options) {
    super(player, options);
    const updateMarker = () => {
      this.el().style.setProperty('left', this.buildLeftStyle());
    };
    this.player().on('durationchange', updateMarker);
    this.one('dispose', () => this.player().off('durationchange', updateMarker));
  }
  createEl() {
    return video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('span', {
      className: 'vjs-marker',
      style: "left: ".concat(this.buildLeftStyle())
    });
  }
  buildLeftStyle() {
    return "".concat(this.options_.timecode / this.player().duration() * 100, "%");
  }
}
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerComponent('ProgressBarMarkerComponent', ProgressBarMarkerComponent);

/***/ }),

/***/ "./src/assets/player/shared/control-bar/storyboard-plugin.ts":
/*!*******************************************************************!*\
  !*** ./src/assets/player/shared/control-bar/storyboard-plugin.ts ***!
  \*******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   StoryboardPlugin: () => (/* binding */ StoryboardPlugin)
/* harmony export */ });
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);

// Big thanks to this beautiful plugin: https://github.com/phloxic/videojs-sprite-thumbnails
// Adapted to respect peertube player style
const Plugin = video_js__WEBPACK_IMPORTED_MODULE_0___default().getPlugin('plugin');
class StoryboardPlugin extends Plugin {
  constructor(player, options) {
    super(player, options);
    this.sprites = {};
    this.url = options.url;
    this.height = options.height;
    this.width = options.width;
    this.interval = options.interval;
    this.boundedHijackMouseTooltip = this.hijackMouseTooltip.bind(this);
    this.init();
    this.player.ready(() => {
      player.addClass('vjs-storyboard');
    });
  }
  init() {
    var _this$progress, _this$seekBar, _this$seekBar2;
    const controls = this.player.controlBar;
    // default control bar component tree is expected
    // https://docs.videojs.com/tutorial-components.html#default-component-tree
    this.progress = controls === null || controls === void 0 ? void 0 : controls.progressControl;
    this.seekBar = (_this$progress = this.progress) === null || _this$progress === void 0 ? void 0 : _this$progress.seekBar;
    this.mouseTimeTooltip = (_this$seekBar = this.seekBar) === null || _this$seekBar === void 0 || (_this$seekBar = _this$seekBar.mouseTimeDisplay) === null || _this$seekBar === void 0 ? void 0 : _this$seekBar.timeTooltip;
    this.spritePlaceholder = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('div', {
      className: 'vjs-storyboard-sprite-placeholder'
    });
    (_this$seekBar2 = this.seekBar) === null || _this$seekBar2 === void 0 || (_this$seekBar2 = _this$seekBar2.el()) === null || _this$seekBar2 === void 0 || _this$seekBar2.appendChild(this.spritePlaceholder);
    this.onReadyOrLoadstartHandler = event => {
      if (event.type !== 'ready') {
        const spriteSource = this.player.currentSources().find(source => {
          return Object.prototype.hasOwnProperty.call(source, 'storyboard');
        });
        const spriteOpts = spriteSource === null || spriteSource === void 0 ? void 0 : spriteSource['storyboard'];
        if (spriteOpts) {
          this.url = spriteOpts.url;
          this.height = spriteOpts.height;
          this.width = spriteOpts.width;
          this.interval = spriteOpts.interval;
        }
      }
      this.cached = !!this.sprites[this.url];
      this.load();
    };
    this.player.on(['ready', 'loadstart'], this.onReadyOrLoadstartHandler);
  }
  dispose() {
    var _this$seekBar3;
    if (this.onReadyOrLoadstartHandler) this.player.off(['ready', 'loadstart'], this.onReadyOrLoadstartHandler);
    if (this.progress) this.progress.off(['mousemove', 'touchmove'], this.boundedHijackMouseTooltip);
    (_this$seekBar3 = this.seekBar) === null || _this$seekBar3 === void 0 || (_this$seekBar3 = _this$seekBar3.el()) === null || _this$seekBar3 === void 0 || _this$seekBar3.removeChild(this.spritePlaceholder);
    super.dispose();
  }
  load() {
    const spriteEvents = ['mousemove', 'touchmove'];
    if (this.isReady()) {
      if (!this.cached) {
        this.sprites[this.url] = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('img', {
          src: this.url
        });
      }
      this.progress.on(spriteEvents, this.boundedHijackMouseTooltip);
    } else {
      this.progress.off(spriteEvents, this.boundedHijackMouseTooltip);
      this.resetMouseTooltip();
    }
  }
  hijackMouseTooltip(evt) {
    const sprite = this.sprites[this.url];
    const imgWidth = sprite.naturalWidth;
    const imgHeight = sprite.naturalHeight;
    const seekBarEl = this.seekBar.el();
    if (!sprite.complete || !imgWidth || !imgHeight) {
      this.resetMouseTooltip();
      return;
    }
    this.player.requestNamedAnimationFrame('StoryBoardPlugin#hijackMouseTooltip', () => {
      const seekBarRect = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.getBoundingClientRect(seekBarEl);
      const playerRect = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.getBoundingClientRect(this.player.el());
      if (!seekBarRect || !playerRect) return;
      const seekBarX = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.getPointerPosition(seekBarEl, evt).x;
      let position = seekBarX * this.player.duration();
      const maxPosition = Math.round(imgHeight / this.height * (imgWidth / this.width)) - 1;
      position = Math.min(position / this.interval, maxPosition);
      const responsive = 600;
      const playerWidth = this.player.currentWidth();
      const scaleFactor = responsive && playerWidth < responsive ? playerWidth / responsive : 1;
      const columns = imgWidth / this.width;
      const scaledWidth = this.width * scaleFactor;
      const scaledHeight = this.height * scaleFactor;
      const cleft = Math.floor(position % columns) * -scaledWidth;
      const ctop = Math.floor(position / columns) * -scaledHeight;
      const bgSize = "".concat(imgWidth * scaleFactor, "px ").concat(imgHeight * scaleFactor, "px");
      const timeTooltip = this.player.el().querySelector('.vjs-time-tooltip');
      const topOffset = -scaledHeight + parseInt(getComputedStyle(timeTooltip).top.replace('px', '')) - 20;
      const previewHalfSize = Math.round(scaledWidth / 2);
      let left = seekBarRect.width * seekBarX - previewHalfSize;
      // Seek bar doesn't take all the player width, so we can add/minus a few more pixels
      const minLeft = playerRect.left - seekBarRect.left;
      const maxLeft = seekBarRect.width - scaledWidth + (playerRect.right - seekBarRect.right);
      if (left < minLeft) left = minLeft;
      if (left > maxLeft) left = maxLeft;
      const tooltipStyle = {
        'background-image': "url(\"".concat(this.url, "\")"),
        'background-repeat': 'no-repeat',
        'background-position': "".concat(cleft, "px ").concat(ctop, "px"),
        'background-size': bgSize,
        'color': '#fff',
        'text-shadow': '1px 1px #000',
        'position': 'relative',
        'top': "".concat(topOffset, "px"),
        'border': '1px solid #000',
        // border should not overlay thumbnail area
        'width': "".concat(scaledWidth + 2, "px"),
        'height': "".concat(scaledHeight + 2, "px")
      };
      tooltipStyle.left = "".concat(left, "px");
      for (const [key, value] of Object.entries(tooltipStyle)) {
        this.spritePlaceholder.style.setProperty(key, value);
      }
    });
  }
  resetMouseTooltip() {
    if (this.spritePlaceholder) {
      this.spritePlaceholder.style.cssText = '';
    }
  }
  isReady() {
    return this.mouseTimeTooltip && this.width && this.height && this.url;
  }
}
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerPlugin('storyboard', StoryboardPlugin);


/***/ }),

/***/ "./src/assets/player/shared/control-bar/theater-button.ts":
/*!****************************************************************!*\
  !*** ./src/assets/player/shared/control-bar/theater-button.ts ***!
  \****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _peertube_player_local_storage__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../../peertube-player-local-storage */ "./src/assets/player/peertube-player-local-storage.ts");
var _TheaterButton;


const Button = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('Button');
class TheaterButton extends Button {
  constructor(player, options) {
    super(player, options);
    this.theaterButtonOptions = options;
    const enabled = (0,_peertube_player_local_storage__WEBPACK_IMPORTED_MODULE_1__.getStoredTheater)();
    if (enabled === true) {
      this.player().addClass(TheaterButton.THEATER_MODE_CLASS);
      this.handleTheaterChange();
    }
    this.controlText('Theater mode');
    this.player().theaterEnabled = enabled;
    this.updateShowing();
    this.player().on('video-change', () => this.updateShowing());
  }
  buildCSSClass() {
    return "vjs-theater-control ".concat(super.buildCSSClass());
  }
  handleTheaterChange() {
    const theaterEnabled = this.isTheaterEnabled();
    if (theaterEnabled) {
      this.controlText('Normal mode');
    } else {
      this.controlText('Theater mode');
    }
    (0,_peertube_player_local_storage__WEBPACK_IMPORTED_MODULE_1__.saveTheaterInStore)(theaterEnabled);
    this.player_.trigger('theater-change', theaterEnabled);
  }
  handleClick() {
    this.player_.toggleClass(TheaterButton.THEATER_MODE_CLASS);
    this.handleTheaterChange();
  }
  isTheaterEnabled() {
    return this.player_.hasClass(TheaterButton.THEATER_MODE_CLASS);
  }
  updateShowing() {
    if (this.theaterButtonOptions.isDisplayed()) this.show();else this.hide();
  }
}
_TheaterButton = TheaterButton;
_TheaterButton.THEATER_MODE_CLASS = 'vjs-theater-enabled';
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerComponent('TheaterButton', TheaterButton);

/***/ }),

/***/ "./src/assets/player/shared/control-bar/time-tooltip.ts":
/*!**************************************************************!*\
  !*** ./src/assets/player/shared/control-bar/time-tooltip.ts ***!
  \**************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @peertube/peertube-core-utils */ "../packages/core-utils/dist/index.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_1__);


const TimeToolTip = video_js__WEBPACK_IMPORTED_MODULE_1___default().getComponent('TimeTooltip'); // FIXME: typings don't have write method
class TimeTooltip extends TimeToolTip {
  write(timecode) {
    const player = this.player();
    if (player.usingPlugin('chapters')) {
      if (timecode === this.currentTimecode) return;
      this.currentTimecode = timecode;
      this.currentChapterTitle = player.chapters().getChapter((0,_peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_0__.timeToInt)(this.currentTimecode));
      if (this.currentChapterTitle) return super.write(this.currentChapterTitle + '\r\n' + this.currentTimecode);
    }
    return super.write(timecode);
  }
}
video_js__WEBPACK_IMPORTED_MODULE_1___default().registerComponent('TimeTooltip', TimeTooltip);

/***/ }),

/***/ "./src/assets/player/shared/hotkeys/peertube-hotkeys-plugin.ts":
/*!*********************************************************************!*\
  !*** ./src/assets/player/shared/hotkeys/peertube-hotkeys-plugin.ts ***!
  \*********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PeerTubeHotkeysPlugin: () => (/* binding */ PeerTubeHotkeysPlugin)
/* harmony export */ });
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);
var _PeerTubeHotkeysPlugin;

const Plugin = video_js__WEBPACK_IMPORTED_MODULE_0___default().getPlugin('plugin');
class PeerTubeHotkeysPlugin extends Plugin {
  constructor(player, options) {
    super(player, options);
    this.isLive = options.isLive;
    this.handlers = this.buildHandlers();
    this.handleKeyFunction = event => this.onKeyDown(event);
    document.addEventListener('keydown', this.handleKeyFunction);
  }
  dispose() {
    document.removeEventListener('keydown', this.handleKeyFunction);
    super.dispose();
  }
  onKeyDown(event) {
    if (!this.isValidKeyTarget(event.target)) return;
    for (const handler of this.handlers) {
      if (handler.accept(event)) {
        handler.cb(event);
        return;
      }
    }
  }
  buildHandlers() {
    const handlers = [
    // Play
    {
      accept: e => e.key === ' ' || e.key === 'MediaPlayPause',
      cb: e => {
        e.preventDefault();
        e.stopPropagation();
        if (this.player.paused()) this.player.play();else this.player.pause();
      }
    },
    // Increase volume
    {
      accept: e => this.isNaked(e, 'ArrowUp'),
      cb: e => {
        e.preventDefault();
        this.player.volume(this.player.volume() + PeerTubeHotkeysPlugin.VOLUME_STEP);
      }
    },
    // Decrease volume
    {
      accept: e => this.isNaked(e, 'ArrowDown'),
      cb: e => {
        e.preventDefault();
        this.player.volume(this.player.volume() - PeerTubeHotkeysPlugin.VOLUME_STEP);
      }
    },
    // Fullscreen
    {
      // f key or Ctrl + Enter
      accept: e => this.isNaked(e, 'f') || !e.altKey && e.ctrlKey && e.key === 'Enter',
      cb: e => {
        e.preventDefault();
        if (this.player.isFullscreen()) this.player.exitFullscreen();else this.player.requestFullscreen();
      }
    },
    // Mute
    {
      accept: e => this.isNaked(e, 'm'),
      cb: e => {
        e.preventDefault();
        this.player.muted(!this.player.muted());
      }
    },
    // Increase playback rate
    {
      accept: e => e.key === '>',
      cb: () => {
        if (this.isLive) return;
        const target = Math.min(this.player.playbackRate() + 0.1, 5);
        this.player.playbackRate(parseFloat(target.toFixed(2)));
      }
    },
    // Decrease playback rate
    {
      accept: e => e.key === '<',
      cb: () => {
        if (this.isLive) return;
        const target = Math.max(this.player.playbackRate() - 0.1, 0.10);
        this.player.playbackRate(parseFloat(target.toFixed(2)));
      }
    },
    // Previous frame
    {
      accept: e => e.key === ',',
      cb: () => {
        if (this.isLive) return;
        this.player.pause();
        // Calculate movement distance (assuming 30 fps)
        const dist = 1 / 30;
        this.player.currentTime(this.player.currentTime() - dist);
      }
    },
    // Next frame
    {
      accept: e => e.key === '.',
      cb: () => {
        if (this.isLive) return;
        this.player.pause();
        // Calculate movement distance (assuming 30 fps)
        const dist = 1 / 30;
        this.player.currentTime(this.player.currentTime() + dist);
      }
    }];
    if (this.isLive) return handlers;
    return handlers.concat(this.buildVODHandlers());
  }
  buildVODHandlers() {
    const handlers = [
    // Rewind
    {
      accept: e => this.isNaked(e, 'ArrowLeft') || this.isNaked(e, 'MediaRewind'),
      cb: e => {
        if (this.isLive) return;
        e.preventDefault();
        const target = Math.max(0, this.player.currentTime() - PeerTubeHotkeysPlugin.SEEK_STEP);
        this.player.currentTime(target);
      }
    },
    // Forward
    {
      accept: e => this.isNaked(e, 'ArrowRight') || this.isNaked(e, 'MediaForward'),
      cb: e => {
        if (this.isLive) return;
        e.preventDefault();
        const target = Math.min(this.player.duration(), this.player.currentTime() + PeerTubeHotkeysPlugin.SEEK_STEP);
        this.player.currentTime(target);
      }
    }];
    // 0-9 key handlers
    for (let i = 0; i < 10; i++) {
      handlers.push({
        accept: e => this.isNakedOrShift(e, i + ''),
        cb: e => {
          if (this.isLive) return;
          e.preventDefault();
          this.player.currentTime(this.player.duration() * i * 0.1);
        }
      });
    }
    return handlers;
  }
  isValidKeyTarget(eventEl) {
    const playerEl = this.player.el();
    const activeEl = document.activeElement;
    const currentElTagName = eventEl.tagName.toLowerCase();
    return activeEl === playerEl || activeEl === playerEl.querySelector('.vjs-tech') || activeEl === playerEl.querySelector('.vjs-control-bar') || eventEl.id === 'content' || currentElTagName === 'body' || currentElTagName === 'video';
  }
  isNaked(event, key) {
    if (key.length === 1) key = key.toUpperCase();
    return !event.ctrlKey && !event.altKey && !event.metaKey && !event.shiftKey && this.getLatinKey(event.key, event.code) === key;
  }
  isNakedOrShift(event, key) {
    return !event.ctrlKey && !event.altKey && !event.metaKey && event.key === key;
  }
  // Thanks Maciej Krawczyk
  // https://stackoverflow.com/questions/70211837/keyboard-shortcuts-commands-on-non-latin-alphabet-keyboards-javascript?rq=1
  getLatinKey(key, code) {
    if (key.length !== 1) {
      return key;
    }
    const capitalHetaCode = 880;
    const isNonLatin = key.charCodeAt(0) >= capitalHetaCode;
    if (isNonLatin) {
      if (code.indexOf('Key') === 0 && code.length === 4) {
        // i.e. 'KeyW'
        return code.charAt(3);
      }
      if (code.indexOf('Digit') === 0 && code.length === 6) {
        // i.e. 'Digit7'
        return code.charAt(5);
      }
    }
    return key.toUpperCase();
  }
}
_PeerTubeHotkeysPlugin = PeerTubeHotkeysPlugin;
_PeerTubeHotkeysPlugin.VOLUME_STEP = 0.1;
_PeerTubeHotkeysPlugin.SEEK_STEP = 5;
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerPlugin('peerTubeHotkeysPlugin', PeerTubeHotkeysPlugin);


/***/ }),

/***/ "./src/assets/player/shared/metrics/metrics-plugin.ts":
/*!************************************************************!*\
  !*** ./src/assets/player/shared/metrics/metrics-plugin.ts ***!
  \************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   MetricsPlugin: () => (/* binding */ MetricsPlugin)
/* harmony export */ });
/* harmony import */ var debug__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! debug */ "./node_modules/debug/src/browser.js");
/* harmony import */ var debug__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(debug__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _root_helpers_logger__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @root-helpers/logger */ "./src/root-helpers/logger.ts");



const debugLogger = debug__WEBPACK_IMPORTED_MODULE_0___default()('peertube:player:metrics');
const Plugin = video_js__WEBPACK_IMPORTED_MODULE_1___default().getPlugin('plugin');
class MetricsPlugin extends Plugin {
  constructor(player, options) {
    super(player);
    this.downloadedBytesP2P = 0;
    this.downloadedBytesHTTP = 0;
    this.uploadedBytesP2P = 0;
    this.resolutionChanges = 0;
    this.errors = 0;
    this.p2pPeers = 0;
    this.options_ = options;
    this.trackBytes();
    this.trackResolutionChange();
    this.trackErrors();
    this.one('play', () => {
      this.player.on('video-change', () => {
        this.runMetricsIntervalOnPlay();
      });
    });
    this.runMetricsIntervalOnPlay();
  }
  dispose() {
    if (this.metricsInterval) clearInterval(this.metricsInterval);
    super.dispose();
  }
  runMetricsIntervalOnPlay() {
    this.downloadedBytesP2P = 0;
    this.downloadedBytesHTTP = 0;
    this.uploadedBytesP2P = 0;
    this.resolutionChanges = 0;
    this.errors = 0;
    this.lastPlayerNetworkInfo = undefined;
    debugLogger('Will track metrics on next play');
    this.player.one('play', () => {
      debugLogger('Tracking metrics');
      this.runMetricsInterval();
    });
  }
  runMetricsInterval() {
    if (this.metricsInterval) clearInterval(this.metricsInterval);
    if (!this.options_.metricsUrl()) return;
    this.metricsInterval = setInterval(() => {
      let resolution;
      let fps;
      if (this.player.usingPlugin('p2pMediaLoader')) {
        const level = this.player.p2pMediaLoader().getCurrentLevel();
        if (!level) return;
        resolution = Math.min(level.height || 0, level.width || 0);
        const framerate = level === null || level === void 0 ? void 0 : level.attrs['FRAME-RATE'];
        fps = framerate ? parseInt(framerate, 10) : undefined;
      } else if (this.player.usingPlugin('webVideo')) {
        const videoFile = this.player.webVideo().getCurrentVideoFile();
        if (!videoFile) return;
        resolution = videoFile.resolution.id;
        fps = videoFile.fps && videoFile.fps !== -1 ? videoFile.fps : undefined;
      } else {
        return;
      }
      const body = {
        resolution: resolution,
        fps,
        playerMode: this.options_.mode(),
        resolutionChanges: this.resolutionChanges,
        errors: this.errors,
        downloadedBytesHTTP: this.downloadedBytesHTTP,
        downloadedBytesP2P: this.downloadedBytesP2P,
        uploadedBytesP2P: this.uploadedBytesP2P,
        p2pPeers: this.p2pPeers,
        p2pEnabled: this.p2pEnabled,
        videoId: this.options_.videoUUID()
      };
      this.resolutionChanges = 0;
      this.downloadedBytesP2P = 0;
      this.downloadedBytesHTTP = 0;
      this.uploadedBytesP2P = 0;
      this.errors = 0;
      const headers = new Headers({
        'Content-type': 'application/json; charset=UTF-8'
      });
      return fetch(this.options_.metricsUrl(), {
        method: 'POST',
        body: JSON.stringify(body),
        headers
      }).catch(err => _root_helpers_logger__WEBPACK_IMPORTED_MODULE_2__.logger.error('Cannot send metrics to the server.', err));
    }, this.options_.metricsInterval());
  }
  trackBytes() {
    this.player.on('network-info', (_event, data) => {
      var _this$lastPlayerNetwo, _data$p2p, _this$lastPlayerNetwo2, _data$p2p2, _this$lastPlayerNetwo3, _data$p2p3;
      this.downloadedBytesHTTP += Math.max(Math.round(data.http.downloaded - (((_this$lastPlayerNetwo = this.lastPlayerNetworkInfo) === null || _this$lastPlayerNetwo === void 0 ? void 0 : _this$lastPlayerNetwo.http.downloaded) || 0)), 0);
      this.downloadedBytesP2P += Math.max(Math.round((((_data$p2p = data.p2p) === null || _data$p2p === void 0 ? void 0 : _data$p2p.downloaded) || 0) - (((_this$lastPlayerNetwo2 = this.lastPlayerNetworkInfo) === null || _this$lastPlayerNetwo2 === void 0 || (_this$lastPlayerNetwo2 = _this$lastPlayerNetwo2.p2p) === null || _this$lastPlayerNetwo2 === void 0 ? void 0 : _this$lastPlayerNetwo2.downloaded) || 0)), 0);
      this.uploadedBytesP2P += Math.max(Math.round((((_data$p2p2 = data.p2p) === null || _data$p2p2 === void 0 ? void 0 : _data$p2p2.uploaded) || 0) - (((_this$lastPlayerNetwo3 = this.lastPlayerNetworkInfo) === null || _this$lastPlayerNetwo3 === void 0 || (_this$lastPlayerNetwo3 = _this$lastPlayerNetwo3.p2p) === null || _this$lastPlayerNetwo3 === void 0 ? void 0 : _this$lastPlayerNetwo3.uploaded) || 0)), 0);
      this.p2pPeers = (_data$p2p3 = data.p2p) === null || _data$p2p3 === void 0 ? void 0 : _data$p2p3.peersP2POnly;
      this.p2pEnabled = !!data.p2p;
      this.lastPlayerNetworkInfo = data;
    });
  }
  trackResolutionChange() {
    this.player.on('resolution-change', (_, _ref) => {
      let {
        initResolutionChange
      } = _ref;
      if (initResolutionChange === true) return;
      debugLogger('Adding resolution change');
      this.resolutionChanges++;
    });
  }
  trackErrors() {
    this.player.on('error', () => {
      this.errors++;
    });
  }
}
video_js__WEBPACK_IMPORTED_MODULE_1___default().registerPlugin('metrics', MetricsPlugin);


/***/ }),

/***/ "./src/assets/player/shared/mobile/peertube-mobile-buttons.ts":
/*!********************************************************************!*\
  !*** ./src/assets/player/shared/mobile/peertube-mobile-buttons.ts ***!
  \********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PeerTubeMobileButtons: () => (/* binding */ PeerTubeMobileButtons)
/* harmony export */ });
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);

const Component = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('Component');
class PeerTubeMobileButtons extends Component {
  createEl() {
    const container = super.createEl('div', {
      className: 'vjs-mobile-buttons-overlay'
    });
    this.mainButton = super.createEl('div', {
      className: 'main-button'
    });
    this.touchStartHandler = e => {
      e.stopPropagation();
      if (this.player_.paused() || this.player_.ended()) {
        this.player_.play();
        return;
      }
      this.player_.pause();
    };
    this.mainButton.addEventListener('touchstart', this.touchStartHandler, {
      passive: true
    });
    this.rewind = super.createEl('div', {
      className: 'rewind-button vjs-hidden'
    });
    this.forward = super.createEl('div', {
      className: 'forward-button vjs-hidden'
    });
    for (let i = 0; i < 3; i++) {
      this.rewind.appendChild(super.createEl('span', {
        className: 'icon'
      }));
      this.forward.appendChild(super.createEl('span', {
        className: 'icon'
      }));
    }
    this.rewindText = this.rewind.appendChild(super.createEl('div', {
      className: 'text'
    }));
    this.forwardText = this.forward.appendChild(super.createEl('div', {
      className: 'text'
    }));
    container.appendChild(this.rewind);
    container.appendChild(this.mainButton);
    container.appendChild(this.forward);
    return container;
  }
  dispose() {
    if (this.touchStartHandler) this.mainButton.removeEventListener('touchstart', this.touchStartHandler);
    super.dispose();
  }
  displayFastSeek(amount) {
    if (amount === 0) {
      this.hideRewind();
      this.hideForward();
      return;
    }
    if (amount > 0) {
      this.hideRewind();
      this.displayForward(amount);
      return;
    }
    if (amount < 0) {
      this.hideForward();
      this.displayRewind(amount);
      return;
    }
  }
  hideRewind() {
    this.rewind.classList.add('vjs-hidden');
    this.rewindText.textContent = '';
  }
  displayRewind(amount) {
    this.rewind.classList.remove('vjs-hidden');
    this.rewindText.textContent = this.player().localize('{1} seconds', [amount + '']);
  }
  hideForward() {
    this.forward.classList.add('vjs-hidden');
    this.forwardText.textContent = '';
  }
  displayForward(amount) {
    this.forward.classList.remove('vjs-hidden');
    this.forwardText.textContent = this.player().localize('{1} seconds', [amount + '']);
  }
}
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerComponent('PeerTubeMobileButtons', PeerTubeMobileButtons);


/***/ }),

/***/ "./src/assets/player/shared/mobile/peertube-mobile-plugin.ts":
/*!*******************************************************************!*\
  !*** ./src/assets/player/shared/mobile/peertube-mobile-plugin.ts ***!
  \*******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PeerTubeMobilePlugin: () => (/* binding */ PeerTubeMobilePlugin)
/* harmony export */ });
/* harmony import */ var debug__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! debug */ "./node_modules/debug/src/browser.js");
/* harmony import */ var debug__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(debug__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _root_helpers_logger__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @root-helpers/logger */ "./src/root-helpers/logger.ts");
var _PeerTubeMobilePlugin;



const debugLogger = debug__WEBPACK_IMPORTED_MODULE_0___default()('peertube:player:mobile');
const Plugin = video_js__WEBPACK_IMPORTED_MODULE_1___default().getPlugin('plugin');
class PeerTubeMobilePlugin extends Plugin {
  constructor(player, options) {
    super(player, options);
    this.seekAmount = 0;
    this.peerTubeMobileButtons = player.addChild('PeerTubeMobileButtons', {
      reportTouchActivity: false
    });
    if ((video_js__WEBPACK_IMPORTED_MODULE_1___default().browser).IS_ANDROID && screen.orientation) {
      this.handleFullscreenRotation();
    }
    if (!this.player.options_.userActions) this.player.options_.userActions = {};
    // FIXME: typings
    this.player.options_.userActions.click = false;
    this.player.options_.userActions.doubleClick = false;
    this.onPlayHandler = () => this.initTouchStartEvents();
    this.player.one('play', this.onPlayHandler);
    this.seekBar = this.player.getDescendant(['controlBar', 'progressControl', 'seekBar']);
    this.sliderActiveHandler = () => this.player.addClass('vjs-mobile-sliding');
    this.sliderInactiveHandler = () => this.player.removeClass('vjs-mobile-sliding');
    this.seekBar.on('slideractive', this.sliderActiveHandler);
    this.seekBar.on('sliderinactive', this.sliderInactiveHandler);
  }
  dispose() {
    if (this.onPlayHandler) this.player.off('play', this.onPlayHandler);
    if (this.onFullScreenChangeHandler) this.player.off('fullscreenchange', this.onFullScreenChangeHandler);
    if (this.onTouchStartHandler) this.player.off('touchstart', this.onFullScreenChangeHandler);
    if (this.onMobileButtonTouchStartHandler) {
      var _this$peerTubeMobileB;
      (_this$peerTubeMobileB = this.peerTubeMobileButtons) === null || _this$peerTubeMobileB === void 0 || _this$peerTubeMobileB.el().removeEventListener('touchstart', this.onMobileButtonTouchStartHandler);
    }
    super.dispose();
  }
  handleFullscreenRotation() {
    this.onFullScreenChangeHandler = () => {
      if (!this.player.isFullscreen() || this.isPortraitVideo()) return;
      // https://github.com/microsoft/TypeScript-DOM-lib-generator/issues/1615
      screen.orientation.lock('landscape').catch(err => _root_helpers_logger__WEBPACK_IMPORTED_MODULE_2__.logger.error('Cannot lock screen to landscape.', err));
    };
    this.player.on('fullscreenchange', this.onFullScreenChangeHandler);
  }
  isPortraitVideo() {
    return this.player.videoWidth() < this.player.videoHeight();
  }
  initTouchStartEvents() {
    const handleTouchStart = event => {
      if (this.tapTimeout) {
        clearTimeout(this.tapTimeout);
        this.tapTimeout = undefined;
      }
      if (this.lastTapEvent && event.timeStamp - this.lastTapEvent.timeStamp < PeerTubeMobilePlugin.DOUBLE_TAP_DELAY_MS) {
        debugLogger('Detected double tap');
        this.lastTapEvent = undefined;
        this.onDoubleTap(event);
        return;
      }
      this.newActiveState = !this.player.userActive();
      this.tapTimeout = setTimeout(() => {
        debugLogger('No double tap detected, set user active state to %s.', this.newActiveState);
        this.player.userActive(this.newActiveState);
      }, PeerTubeMobilePlugin.DOUBLE_TAP_DELAY_MS);
      this.lastTapEvent = event;
    };
    this.onTouchStartHandler = event => {
      // Only enable user active on player touch, we listen event on peertube mobile buttons to disable it
      if (this.player.userActive()) return;
      handleTouchStart(event);
    };
    this.player.on('touchstart', this.onTouchStartHandler);
    this.onMobileButtonTouchStartHandler = event => {
      // Prevent mousemove/click events firing on the player, that conflict with our user active logic
      event.preventDefault();
      handleTouchStart(event);
    };
    this.peerTubeMobileButtons.el().addEventListener('touchstart', this.onMobileButtonTouchStartHandler, {
      passive: false
    });
  }
  onDoubleTap(event) {
    const playerWidth = this.player.currentWidth();
    const rect = this.findPlayerTarget(event.target).getBoundingClientRect();
    const offsetX = event.targetTouches[0].pageX - rect.left;
    debugLogger('Calculating double tap zone (player width: %d, offset X: %d)', playerWidth, offsetX);
    if (offsetX > 0.66 * playerWidth) {
      if (this.seekAmount < 0) this.seekAmount = 0;
      this.seekAmount += 10;
      debugLogger('Will forward %d seconds', this.seekAmount);
    } else if (offsetX < 0.33 * playerWidth) {
      if (this.seekAmount > 0) this.seekAmount = 0;
      this.seekAmount -= 10;
      debugLogger('Will rewind %d seconds', this.seekAmount);
    }
    this.peerTubeMobileButtons.displayFastSeek(this.seekAmount);
    this.scheduleSetCurrentTime();
  }
  findPlayerTarget(target) {
    if (target.classList.contains('video-js')) return target;
    return this.findPlayerTarget(target.parentElement);
  }
  scheduleSetCurrentTime() {
    this.player.pause();
    this.player.addClass('vjs-fast-seeking');
    if (this.setCurrentTimeTimeout) clearTimeout(this.setCurrentTimeTimeout);
    this.setCurrentTimeTimeout = setTimeout(() => {
      let newTime = this.player.currentTime() + this.seekAmount;
      this.seekAmount = 0;
      newTime = Math.max(0, newTime);
      newTime = Math.min(this.player.duration(), newTime);
      this.player.currentTime(newTime);
      this.seekAmount = 0;
      this.peerTubeMobileButtons.displayFastSeek(0);
      this.player.removeClass('vjs-fast-seeking');
      this.player.userActive(false);
      this.player.play();
    }, PeerTubeMobilePlugin.SET_CURRENT_TIME_DELAY);
  }
}
_PeerTubeMobilePlugin = PeerTubeMobilePlugin;
_PeerTubeMobilePlugin.DOUBLE_TAP_DELAY_MS = 250;
_PeerTubeMobilePlugin.SET_CURRENT_TIME_DELAY = 1000;
video_js__WEBPACK_IMPORTED_MODULE_1___default().registerPlugin('peertubeMobile', PeerTubeMobilePlugin);


/***/ }),

/***/ "./src/assets/player/shared/p2p-media-loader/redundancy-url-manager.ts":
/*!*****************************************************************************!*\
  !*** ./src/assets/player/shared/p2p-media-loader/redundancy-url-manager.ts ***!
  \*****************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   RedundancyUrlManager: () => (/* binding */ RedundancyUrlManager)
/* harmony export */ });
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! path */ "./src/shims/path.ts");
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(path__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _root_helpers_logger__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @root-helpers/logger */ "./src/root-helpers/logger.ts");


class RedundancyUrlManager {
  constructor() {
    let baseUrls = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    this.baseUrls = baseUrls;
    // empty
  }
  removeBySegmentUrl(segmentUrl) {
    _root_helpers_logger__WEBPACK_IMPORTED_MODULE_1__.logger.info("Removing redundancy of segment URL ".concat(segmentUrl, "."));
    const baseUrl = (0,path__WEBPACK_IMPORTED_MODULE_0__.dirname)(segmentUrl);
    this.baseUrls = this.baseUrls.filter(u => u !== baseUrl && u !== baseUrl + '/');
  }
  buildUrl(url) {
    const max = this.baseUrls.length + 1;
    const i = this.getRandomInt(max);
    if (i === max - 1) return url;
    const newBaseUrl = this.baseUrls[i];
    const slashPart = newBaseUrl.endsWith('/') ? '' : '/';
    return newBaseUrl + slashPart + (0,path__WEBPACK_IMPORTED_MODULE_0__.basename)(url);
  }
  countBaseUrls() {
    return this.baseUrls.length;
  }
  getRandomInt(max) {
    return Math.floor(Math.random() * Math.floor(max));
  }
}
// ---------------------------------------------------------------------------


/***/ }),

/***/ "./src/assets/player/shared/p2p-media-loader/segment-url-builder.ts":
/*!**************************************************************************!*\
  !*** ./src/assets/player/shared/p2p-media-loader/segment-url-builder.ts ***!
  \**************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   segmentUrlBuilderFactory: () => (/* binding */ segmentUrlBuilderFactory)
/* harmony export */ });
function segmentUrlBuilderFactory(redundancyUrlManager) {
  return function segmentBuilder(segment) {
    return redundancyUrlManager.buildUrl(segment.url);
  };
}
// ---------------------------------------------------------------------------


/***/ }),

/***/ "./src/assets/player/shared/p2p-media-loader/segment-validator.ts":
/*!************************************************************************!*\
  !*** ./src/assets/player/shared/p2p-media-loader/segment-validator.ts ***!
  \************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   SegmentValidator: () => (/* binding */ SegmentValidator)
/* harmony export */ });
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! path */ "./src/shims/path.ts");
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(path__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _root_helpers_logger__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @root-helpers/logger */ "./src/root-helpers/logger.ts");
/* harmony import */ var _root_helpers_utils__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @root-helpers/utils */ "./src/root-helpers/utils.ts");
/* harmony import */ var _peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @peertube/peertube-core-utils */ "../packages/core-utils/dist/index.js");
/* harmony import */ var _common__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../common */ "./src/assets/player/shared/common/index.ts");
/* provided dependency */ var Buffer = __webpack_require__(/*! buffer */ "./node_modules/buffer/index.js")["Buffer"];





const maxRetries = 10;
class SegmentValidator {
  constructor(options) {
    this.options = options;
    this.bytesRangeRegex = /bytes=(\d+)-(\d+)/;
    this.destroyed = false;
  }
  async validate(segment, _method, _peerId) {
    let retry = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 1;
    if (this.destroyed) return;
    this.loadSha256SegmentsPromiseIfNeeded();
    const filename = (0,path__WEBPACK_IMPORTED_MODULE_0__.basename)((0,_peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_3__.removeQueryParams)(segment.url));
    const segmentValue = (await this.segmentJSONPromise)[filename];
    if (!segmentValue && retry > maxRetries) {
      throw new Error("Unknown segment name ".concat(filename, " in segment validator"));
    }
    if (!segmentValue) {
      _root_helpers_logger__WEBPACK_IMPORTED_MODULE_1__.logger.info("Refetching sha segments for ".concat(filename));
      await (0,_root_helpers_utils__WEBPACK_IMPORTED_MODULE_2__.wait)(500);
      this.loadSha256SegmentsPromise();
      await this.validate(segment, _method, _peerId, retry + 1);
      return;
    }
    let hashShouldBe;
    let range = '';
    if (typeof segmentValue === 'string') {
      hashShouldBe = segmentValue;
    } else {
      const captured = this.bytesRangeRegex.exec(segment.range);
      range = captured[1] + '-' + captured[2];
      hashShouldBe = segmentValue[range];
    }
    if (hashShouldBe === undefined) {
      throw new Error("Unknown segment name ".concat(filename, "/").concat(range, " in segment validator"));
    }
    const calculatedSha = await this.sha256Hex(segment.data);
    if (calculatedSha !== hashShouldBe) {
      throw new Error("Hashes does not correspond for segment ".concat(filename, "/").concat(range) + "(expected: ".concat(hashShouldBe, " instead of ").concat(calculatedSha, ")"));
    }
  }
  destroy() {
    this.destroyed = true;
  }
  loadSha256SegmentsPromiseIfNeeded() {
    if (this.segmentJSONPromise) return;
    this.loadSha256SegmentsPromise();
  }
  loadSha256SegmentsPromise() {
    this.segmentJSONPromise = this.fetchSha256Segments();
  }
  fetchSha256Segments() {
    let headers = {};
    if ((0,_common__WEBPACK_IMPORTED_MODULE_4__.isSameOrigin)(this.options.serverUrl, this.options.segmentsSha256Url)) {
      if (this.options.requiresPassword) headers = {
        'x-peertube-video-password': this.options.videoPassword()
      };else if (this.options.requiresUserAuth) headers = {
        Authorization: this.options.authorizationHeader()
      };
    }
    return fetch(this.options.segmentsSha256Url, {
      headers
    }).then(res => res.json()).catch(err => {
      _root_helpers_logger__WEBPACK_IMPORTED_MODULE_1__.logger.error('Cannot get sha256 segments', err);
      return {};
    });
  }
  async sha256Hex(data) {
    if (!data) return undefined;
    if (window.crypto.subtle) {
      return window.crypto.subtle.digest('SHA-256', data).then(data => this.bufferToHex(data));
    }
    // Fallback for non HTTPS context
    const shaModule = (await __webpack_require__.e(/*! import() */ "vendors-node_modules_sha_js_index_js").then(__webpack_require__.t.bind(__webpack_require__, /*! sha.js */ "./node_modules/sha.js/index.js", 23))).default;
    // eslint-disable-next-line new-cap
    return new shaModule.sha256().update(Buffer.from(data)).digest('hex');
  }
  // Thanks: https://stackoverflow.com/a/53307879
  bufferToHex(buffer) {
    if (!buffer) return '';
    let s = '';
    const h = '0123456789abcdef';
    const o = new Uint8Array(buffer);
    o.forEach(v => {
      s += h[v >> 4] + h[v & 15];
    });
    return s;
  }
}

/***/ }),

/***/ "./src/assets/player/shared/peertube/peertube-plugin.ts":
/*!**************************************************************!*\
  !*** ./src/assets/player/shared/peertube/peertube-plugin.ts ***!
  \**************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PeerTubePlugin: () => (/* binding */ PeerTubePlugin)
/* harmony export */ });
/* harmony import */ var _peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @peertube/peertube-core-utils */ "../packages/core-utils/dist/index.js");
/* harmony import */ var _root_helpers_logger__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @root-helpers/logger */ "./src/root-helpers/logger.ts");
/* harmony import */ var _root_helpers_web_browser__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @root-helpers/web-browser */ "./src/root-helpers/web-browser.ts");
/* harmony import */ var debug__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! debug */ "./node_modules/debug/src/browser.js");
/* harmony import */ var debug__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(debug__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _peertube_player_local_storage__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../../peertube-player-local-storage */ "./src/assets/player/peertube-player-local-storage.ts");






const debugLogger = debug__WEBPACK_IMPORTED_MODULE_3___default()('peertube:player:peertube');
const Plugin = video_js__WEBPACK_IMPORTED_MODULE_4___default().getPlugin('plugin');
class PeerTubePlugin extends Plugin {
  constructor(player, options) {
    super(player);
    this.options = options;
    this.menuOpened = false;
    this.mouseInControlBar = false;
    this.mouseInSettings = false;
    this.hasInitialSeek = false;
    this.videoViewUrl = options.videoViewUrl;
    this.authorizationHeader = options.authorizationHeader;
    this.hasAutoplay = options.hasAutoplay;
    this.initialInactivityTimeout = this.player.options_.inactivityTimeout;
    this.currentSubtitle = this.options.subtitle() || (0,_peertube_player_local_storage__WEBPACK_IMPORTED_MODULE_5__.getStoredLastSubtitle)();
    this.initializePlayer();
    this.initOnVideoChange();
    this.player.removeClass('vjs-can-play');
    this.deleteLegacyIndexedDB();
    this.player.on('autoplay-failure', () => {
      debugLogger('Autoplay failed');
      this.player.removeClass('vjs-has-autoplay');
      this.player.poster(options.poster());
      // Fix a bug on iOS/Safari where the big play button is not displayed when autoplay fails
      if ((0,_root_helpers_web_browser__WEBPACK_IMPORTED_MODULE_2__.isIOS)() || (0,_root_helpers_web_browser__WEBPACK_IMPORTED_MODULE_2__.isSafari)()) this.player.hasStarted(false);
    });
    this.player.on('ratechange', () => {
      this.currentPlaybackRate = this.player.playbackRate();
      this.player.defaultPlaybackRate(this.currentPlaybackRate);
    });
    this.player.one('canplay', () => {
      const playerOptions = this.player.options_;
      const volume = (0,_peertube_player_local_storage__WEBPACK_IMPORTED_MODULE_5__.getStoredVolume)();
      if (volume !== undefined) this.player.volume(volume);
      const muted = playerOptions.muted !== undefined ? playerOptions.muted : (0,_peertube_player_local_storage__WEBPACK_IMPORTED_MODULE_5__.getStoredMute)();
      if (muted !== undefined) this.player.muted(muted);
      this.player.addClass('vjs-can-play');
    });
    this.player.ready(() => {
      this.player.on('volumechange', () => {
        (0,_peertube_player_local_storage__WEBPACK_IMPORTED_MODULE_5__.saveVolumeInStore)(this.player.volume());
        (0,_peertube_player_local_storage__WEBPACK_IMPORTED_MODULE_5__.saveMuteInStore)(this.player.muted());
      });
      this.player.textTracks().addEventListener('change', () => {
        const showing = this.player.textTracks().tracks_.find(t => {
          return t.kind === 'captions' && t.mode === 'showing';
        });
        if (!showing) {
          (0,_peertube_player_local_storage__WEBPACK_IMPORTED_MODULE_5__.saveLastSubtitle)('off');
          this.currentSubtitle = undefined;
          return;
        }
        if (this.currentSubtitle === showing.language) return;
        this.currentSubtitle = showing.language;
        (0,_peertube_player_local_storage__WEBPACK_IMPORTED_MODULE_5__.saveLastSubtitle)(showing.language);
        (0,_peertube_player_local_storage__WEBPACK_IMPORTED_MODULE_5__.savePreferredSubtitle)(showing.language);
      });
      this.player.on('video-change', () => {
        this.initOnVideoChange();
        this.hideFatalError();
      });
      this.updatePlayerSizeClasses();
      if (typeof ResizeObserver !== 'undefined') {
        this.resizeObserver = new ResizeObserver(() => {
          this.updatePlayerSizeClasses();
        });
        this.resizeObserver.observe(this.player.el());
      }
    });
    this.player.on('resolution-change', (_, _ref) => {
      let {
        resolution
      } = _ref;
      if (this.player.paused()) {
        this.player.on('play', () => this.adaptPosterForAudioOnly(resolution));
        return;
      }
      this.adaptPosterForAudioOnly(resolution);
    });
    this.initOnRatioChange();
  }
  dispose() {
    if (this.videoViewInterval) clearInterval(this.videoViewInterval);
    if (this.resizeObserver) this.resizeObserver.disconnect();
    super.dispose();
  }
  onMenuOpened() {
    this.menuOpened = true;
    this.alterInactivity();
  }
  onMenuClosed() {
    this.menuOpened = false;
    this.alterInactivity();
  }
  displayFatalError() {
    // Already displayed an error
    if (this.errorModal) return;
    debugLogger('Display fatal error');
    this.player.loadingSpinner.hide();
    const buildModal = error => {
      const localize = this.player.localize.bind(this.player);
      const wrapper = document.createElement('div');
      const header = document.createElement('h1');
      header.innerText = localize('Failed to play video');
      wrapper.appendChild(header);
      const desc = document.createElement('div');
      desc.innerText = localize('The video failed to play due to technical issues.');
      wrapper.appendChild(desc);
      const details = document.createElement('p');
      details.classList.add('error-details');
      details.innerText = error.message;
      wrapper.appendChild(details);
      return wrapper;
    };
    this.errorModal = this.player.createModal(buildModal(this.player.error()), {
      temporary: true,
      uncloseable: true
    });
    this.errorModal.addClass('vjs-custom-error-display');
    this.player.addClass('vjs-error-display-enabled');
  }
  hideFatalError() {
    if (!this.errorModal) return;
    debugLogger('Hiding fatal error');
    this.player.removeClass('vjs-error-display-enabled');
    this.player.removeChild(this.errorModal);
    this.errorModal.close();
    this.errorModal = undefined;
    if (this.player.loadingSpinner) {
      this.player.loadingSpinner.show();
    }
  }
  initializePlayer() {
    if ((0,_root_helpers_web_browser__WEBPACK_IMPORTED_MODULE_2__.isMobile)()) this.player.addClass('vjs-is-mobile');
    this.initSmoothProgressBar();
    this.player.ready(() => {
      this.listenControlBarMouse();
    });
    this.listenFullScreenChange();
  }
  initOnVideoChange() {
    if (this.hasAutoplay() !== false) this.player.addClass('vjs-has-autoplay');else this.player.removeClass('vjs-has-autoplay');
    if (this.currentPlaybackRate && this.currentPlaybackRate !== 1) {
      debugLogger('Setting playback rate to ' + this.currentPlaybackRate);
      this.player.playbackRate(this.currentPlaybackRate);
    }
    this.player.ready(() => {
      this.initCaptions();
      this.updateControlBar();
    });
    this.handleStartStopTime();
    this.runUserViewing();
  }
  initOnRatioChange() {
    if (!this.options.autoPlayerRatio) return;
    const defaultRatio = getComputedStyle(this.player.el()).getPropertyValue(this.options.autoPlayerRatio.cssRatioVariable);
    const tryToUpdateRatioFromOptions = () => {
      if (!this.options.videoRatio()) return;
      this.adaptPlayerFromRatio({
        ratio: this.options.videoRatio(),
        defaultRatio
      });
      this.updatePlayerSizeClasses();
    };
    tryToUpdateRatioFromOptions();
    this.player.on('video-change', () => tryToUpdateRatioFromOptions());
    this.player.on('video-ratio-changed', (_event, data) => {
      if (this.options.videoRatio()) return;
      this.adaptPlayerFromRatio({
        ratio: data.ratio,
        defaultRatio
      });
      this.updatePlayerSizeClasses();
    });
  }
  adaptPlayerFromRatio(options) {
    const {
      ratio,
      defaultRatio
    } = options;
    const el = this.player.el();
    // In portrait screen mode, we allow player with bigger height size than width
    const portraitMode = getComputedStyle(el).getPropertyValue(this.options.autoPlayerRatio.cssPlayerPortraitModeVariable) === '1';
    const currentRatio = isNaN(ratio) || !portraitMode && ratio < 1 ? defaultRatio : ratio;
    el.style.setProperty('--player-ratio', currentRatio + '');
  }
  // ---------------------------------------------------------------------------
  runUserViewing() {
    const startTime = (0,_peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_0__.timeToInt)(this.options.startTime());
    let lastCurrentTime = startTime;
    let lastViewEvent;
    let ended = false; // player.ended() is too "slow", so handle ended manually
    if (this.videoViewInterval) clearInterval(this.videoViewInterval);
    if (this.videoViewOnPlayHandler) this.player.off('play', this.videoViewOnPlayHandler);
    if (this.videoViewOnSeekedHandler) this.player.off('seeked', this.videoViewOnSeekedHandler);
    if (this.videoViewOnEndedHandler) this.player.off('ended', this.videoViewOnEndedHandler);
    this.videoViewOnPlayHandler = () => {
      debugLogger('Notify user is watching on play: ' + startTime);
      this.notifyUserIsWatching(startTime, lastViewEvent);
    };
    this.videoViewOnSeekedHandler = () => {
      // Bypass the first initial seek
      if (this.hasInitialSeek) {
        this.hasInitialSeek = false;
        return;
      }
      const diff = Math.floor(this.player.currentTime()) - lastCurrentTime;
      // Don't take into account small forwards
      if (diff > 0 && diff < 3) return;
      debugLogger('Detected seek event for user watching');
      lastViewEvent = 'seek';
    };
    this.videoViewOnEndedHandler = () => {
      ended = true;
      if (this.options.isLive()) return;
      const currentTime = Math.floor(this.player.duration());
      lastCurrentTime = currentTime;
      debugLogger('Notify user is watching on end: ' + currentTime);
      this.notifyUserIsWatching(currentTime, lastViewEvent);
      lastViewEvent = undefined;
    };
    this.player.one('play', this.videoViewOnPlayHandler);
    this.player.on('seeked', this.videoViewOnSeekedHandler);
    this.player.one('ended', this.videoViewOnEndedHandler);
    this.videoViewInterval = setInterval(() => {
      if (ended) return;
      const currentTime = Math.floor(this.player.currentTime());
      // No need to update
      if (currentTime === lastCurrentTime) return;
      debugLogger('Notify user is watching: ' + currentTime);
      lastCurrentTime = currentTime;
      this.notifyUserIsWatching(currentTime, lastViewEvent).catch(err => _root_helpers_logger__WEBPACK_IMPORTED_MODULE_1__.logger.error('Cannot notify user is watching.', err));
      lastViewEvent = undefined;
    }, this.options.videoViewIntervalMs);
  }
  notifyUserIsWatching(currentTime, viewEvent) {
    // Server won't save history, so save the video position in local storage
    if (!this.authorizationHeader()) {
      (0,_peertube_player_local_storage__WEBPACK_IMPORTED_MODULE_5__.saveVideoWatchHistory)(this.options.videoUUID(), currentTime);
    }
    if (!this.videoViewUrl()) return Promise.resolve(true);
    const sessionId = (0,_peertube_player_local_storage__WEBPACK_IMPORTED_MODULE_5__.getPlayerSessionId)();
    const body = {
      currentTime,
      viewEvent,
      sessionId
    };
    const headers = new Headers({
      'Content-type': 'application/json; charset=UTF-8'
    });
    if (this.authorizationHeader()) headers.set('Authorization', this.authorizationHeader());
    return fetch(this.videoViewUrl(), {
      method: 'POST',
      body: JSON.stringify(body),
      headers
    });
  }
  // ---------------------------------------------------------------------------
  adaptPosterForAudioOnly(resolution) {
    debugLogger('Check if we need to adapt player for audio only', resolution);
    if (resolution === 0) {
      this.player.audioPosterMode(true);
      this.player.poster(this.options.poster());
      return;
    }
    this.player.audioPosterMode(false);
    this.player.poster('');
  }
  // ---------------------------------------------------------------------------
  updatePlayerSizeClasses() {
    requestAnimationFrame(() => {
      if (!this.player) return;
      debugLogger('Updating player size classes');
      const width = this.player.currentWidth();
      const breakpoints = [350, 570, 750];
      for (const breakpoint of breakpoints) {
        if (width <= breakpoint) {
          this.player.addClass('vjs-size-' + breakpoint);
        } else {
          this.player.removeClass('vjs-size-' + breakpoint);
        }
      }
    });
  }
  // ---------------------------------------------------------------------------
  listenFullScreenChange() {
    this.player.on('fullscreenchange', () => {
      if (this.player.isFullscreen()) this.player.focus();
    });
  }
  listenControlBarMouse() {
    const controlBar = this.player.controlBar;
    const settingsButton = controlBar.settingsButton;
    controlBar.on('mouseenter', () => {
      this.mouseInControlBar = true;
      this.alterInactivity();
    });
    controlBar.on('mouseleave', () => {
      this.mouseInControlBar = false;
      this.alterInactivity();
    });
    settingsButton.dialog.on('mouseenter', () => {
      this.mouseInSettings = true;
      this.alterInactivity();
    });
    settingsButton.dialog.on('mouseleave', () => {
      this.mouseInSettings = false;
      this.alterInactivity();
    });
  }
  alterInactivity() {
    if (this.menuOpened || this.mouseInSettings || this.mouseInControlBar) {
      this.setInactivityTimeout(0);
      return;
    }
    this.setInactivityTimeout(this.initialInactivityTimeout);
    this.player.reportUserActivity(true);
  }
  setInactivityTimeout(timeout) {
    this.player.cache_.inactivityTimeout = timeout;
    this.player.options_.inactivityTimeout = timeout;
  }
  initCaptions() {
    if (this.currentSubtitle) debugLogger('Init captions with current subtitle ' + this.currentSubtitle);else debugLogger('Init captions without current subtitle');
    this.player.tech(true).clearTracks('text');
    this.player.removeClass('vjs-has-captions');
    for (const caption of this.options.videoCaptions()) {
      this.player.addRemoteTextTrack({
        kind: 'captions',
        label: caption.label,
        language: caption.language,
        id: caption.language,
        src: caption.src,
        default: this.currentSubtitle === caption.language
      }, true);
      this.player.addClass('vjs-has-captions');
    }
    this.player.trigger('captions-changed');
  }
  updateControlBar() {
    debugLogger('Updating control bar');
    if (this.options.isLive()) {
      this.getPlaybackRateButton().hide();
      this.player.controlBar.getChild('progressControl').hide();
      this.player.controlBar.getChild('currentTimeDisplay').hide();
      this.player.controlBar.getChild('timeDivider').hide();
      this.player.controlBar.getChild('durationDisplay').hide();
      this.player.controlBar.getChild('peerTubeLiveDisplay').show();
    } else {
      this.getPlaybackRateButton().show();
      this.player.controlBar.getChild('progressControl').show();
      this.player.controlBar.getChild('currentTimeDisplay').show();
      this.player.controlBar.getChild('timeDivider').show();
      this.player.controlBar.getChild('durationDisplay').show();
      this.player.controlBar.getChild('peerTubeLiveDisplay').hide();
    }
    if (this.options.videoCaptions().length === 0) {
      this.getCaptionsButton().hide();
    } else {
      this.getCaptionsButton().show();
    }
  }
  handleStartStopTime() {
    this.player.duration(this.options.videoDuration());
    if (this.stopTimeHandler) {
      this.player.off('timeupdate', this.stopTimeHandler);
      this.stopTimeHandler = undefined;
    }
    // Prefer canplaythrough instead of canplay because Chrome has issues with the second one
    this.player.one('canplaythrough', () => {
      const startTime = this.options.startTime();
      if (startTime !== null && startTime !== undefined) {
        debugLogger('Start the video at ' + startTime);
        this.hasInitialSeek = true;
        this.player.currentTime((0,_peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_0__.timeToInt)(startTime));
      }
      if (this.options.stopTime()) {
        const stopTime = (0,_peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_0__.timeToInt)(this.options.stopTime());
        this.stopTimeHandler = () => {
          if (this.player.currentTime() <= stopTime) return;
          debugLogger('Stopping the video at ' + this.options.stopTime());
          // Time top stop
          this.player.pause();
          this.player.trigger('auto-stopped');
          this.player.off('timeupdate', this.stopTimeHandler);
          this.stopTimeHandler = undefined;
        };
        this.player.on('timeupdate', this.stopTimeHandler);
      }
    });
  }
  // Thanks: https://github.com/videojs/video.js/issues/4460#issuecomment-312861657
  initSmoothProgressBar() {
    const SeekBar = video_js__WEBPACK_IMPORTED_MODULE_4___default().getComponent('SeekBar');
    SeekBar.prototype.getPercent = function getPercent() {
      // Allows for smooth scrubbing, when player can't keep up.
      // const time = (this.player_.scrubbing()) ?
      //   this.player_.getCache().currentTime :
      //   this.player_.currentTime()
      const time = this.player_.currentTime();
      const percent = time / this.player_.duration();
      return percent >= 1 ? 1 : percent;
    };
    SeekBar.prototype.handleMouseMove = function handleMouseMove(event) {
      let newTime = this.calculateDistance(event) * this.player_.duration();
      if (newTime === this.player_.duration()) {
        newTime = newTime - 0.1;
      }
      this.player_.currentTime(newTime);
      this.update();
    };
  }
  getCaptionsButton() {
    const settingsButton = this.player.controlBar.getDescendant(['settingsButton']);
    return settingsButton.menu.getChild('captionsButton');
  }
  getPlaybackRateButton() {
    const settingsButton = this.player.controlBar.getDescendant(['settingsButton']);
    return settingsButton.menu.getChild('playbackRateMenuButton');
  }
  // We don't use webtorrent anymore, so we can safely remove old chunks from IndexedDB
  deleteLegacyIndexedDB() {
    try {
      if (typeof window.indexedDB === 'undefined') return;
      if (!window.indexedDB) return;
      if (typeof window.indexedDB.databases !== 'function') return;
      window.indexedDB.databases().then(databases => {
        for (const db of databases) {
          window.indexedDB.deleteDatabase(db.name);
        }
      });
    } catch (err) {
      debugLogger('Cannot delete legacy indexed DB', err);
      // Nothing to do
    }
  }
}
video_js__WEBPACK_IMPORTED_MODULE_4___default().registerPlugin('peertube', PeerTubePlugin);


/***/ }),

/***/ "./src/assets/player/shared/player-options-builder/control-bar-options-builder.ts":
/*!****************************************************************************************!*\
  !*** ./src/assets/player/shared/player-options-builder/control-bar-options-builder.ts ***!
  \****************************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ControlBarOptionsBuilder: () => (/* binding */ ControlBarOptionsBuilder)
/* harmony export */ });
class ControlBarOptionsBuilder {
  constructor(options) {
    this.options = options;
  }
  getChildrenOptions() {
    const children = {
      ...this.getPreviousVideo(),
      playToggle: {},
      ...this.getNextVideo(),
      ...this.getTimeControls(),
      ...this.getProgressControl(),
      p2PInfoButton: {},
      muteToggle: {},
      volumeControl: {},
      captionToggleButton: {},
      ...this.getSettingsButton(),
      ...this.getPeerTubeLinkButton(),
      ...this.getTheaterButton(),
      fullscreenToggle: {}
    };
    return children;
  }
  getSettingsButton() {
    const settingEntries = [];
    settingEntries.push('playbackRateMenuButton');
    settingEntries.push('captionsButton');
    settingEntries.push('resolutionMenuButton');
    return {
      settingsButton: {
        setup: {
          maxHeightOffset: 60
        },
        entries: settingEntries
      }
    };
  }
  getTimeControls() {
    return {
      peerTubeLiveDisplay: {},
      currentTimeDisplay: {},
      timeDivider: {},
      durationDisplay: {}
    };
  }
  getProgressControl() {
    return {
      progressControl: {
        children: {
          seekBar: {
            children: {
              loadProgressBar: {},
              mouseTimeDisplay: {},
              playProgressBar: {}
            }
          }
        }
      }
    };
  }
  getPreviousVideo() {
    const buttonOptions = {
      type: 'previous',
      handler: () => this.options.previousVideo().handler(),
      isDisabled: () => !this.options.previousVideo().enabled,
      isDisplayed: () => this.options.previousVideo().displayControlBarButton
    };
    return {
      previousVideoButton: buttonOptions
    };
  }
  getNextVideo() {
    const buttonOptions = {
      type: 'next',
      handler: () => this.options.nextVideo().handler(),
      isDisabled: () => !this.options.nextVideo().enabled,
      isDisplayed: () => this.options.nextVideo().displayControlBarButton
    };
    return {
      nextVideoButton: buttonOptions
    };
  }
  getPeerTubeLinkButton() {
    const options = {
      isDisplayed: this.options.peertubeLink,
      shortUUID: this.options.videoShortUUID,
      instanceName: this.options.instanceName
    };
    return {
      peerTubeLinkButton: options
    };
  }
  getTheaterButton() {
    const options = {
      isDisplayed: () => this.options.theaterButton
    };
    return {
      theaterButton: options
    };
  }
}

/***/ }),

/***/ "./src/assets/player/shared/player-options-builder/hls-options-builder.ts":
/*!********************************************************************************!*\
  !*** ./src/assets/player/shared/player-options-builder/hls-options-builder.ts ***!
  \********************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   HLSOptionsBuilder: () => (/* binding */ HLSOptionsBuilder)
/* harmony export */ });
/* harmony import */ var _root_helpers_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @root-helpers/logger */ "./src/root-helpers/logger.ts");
/* harmony import */ var _peertube_peertube_models__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @peertube/peertube-models */ "../packages/models/dist/index.js");
/* harmony import */ var _peertube_player_local_storage__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../../peertube-player-local-storage */ "./src/assets/player/peertube-player-local-storage.ts");
/* harmony import */ var _common__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../common */ "./src/assets/player/shared/common/index.ts");
/* harmony import */ var _p2p_media_loader_redundancy_url_manager__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../p2p-media-loader/redundancy-url-manager */ "./src/assets/player/shared/p2p-media-loader/redundancy-url-manager.ts");
/* harmony import */ var _p2p_media_loader_segment_url_builder__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../p2p-media-loader/segment-url-builder */ "./src/assets/player/shared/p2p-media-loader/segment-url-builder.ts");
/* harmony import */ var _p2p_media_loader_segment_validator__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../p2p-media-loader/segment-validator */ "./src/assets/player/shared/p2p-media-loader/segment-validator.ts");
/* harmony import */ var _root_helpers_peertube_web_storage__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @root-helpers/peertube-web-storage */ "./src/root-helpers/peertube-web-storage.ts");








class HLSOptionsBuilder {
  constructor(options, p2pMediaLoaderModule) {
    this.options = options;
    this.p2pMediaLoaderModule = p2pMediaLoaderModule;
  }
  async getPluginOptions() {
    const redundancyUrlManager = new _p2p_media_loader_redundancy_url_manager__WEBPACK_IMPORTED_MODULE_4__.RedundancyUrlManager(this.options.hls.redundancyBaseUrls);
    const segmentValidator = new _p2p_media_loader_segment_validator__WEBPACK_IMPORTED_MODULE_6__.SegmentValidator({
      segmentsSha256Url: this.options.hls.segmentsSha256Url,
      authorizationHeader: this.options.authorizationHeader,
      requiresUserAuth: this.options.requiresUserAuth,
      serverUrl: this.options.serverUrl,
      requiresPassword: this.options.requiresPassword,
      videoPassword: this.options.videoPassword
    });
    const p2pMediaLoaderConfig = await this.options.pluginsManager.runHook('filter:internal.player.p2p-media-loader.options.result', this.getP2PMediaLoaderOptions({
      redundancyUrlManager,
      segmentValidator
    }));
    const loader = new this.p2pMediaLoaderModule.Engine(p2pMediaLoaderConfig).createLoaderClass();
    const p2pMediaLoader = {
      requiresUserAuth: this.options.requiresUserAuth,
      videoFileToken: this.options.videoFileToken,
      p2pEnabled: this.options.p2pEnabled,
      redundancyUrlManager,
      type: 'application/x-mpegURL',
      src: this.options.hls.playlistUrl,
      segmentValidator,
      loader
    };
    const hlsjs = {
      hlsjsConfig: this.getHLSJSOptions(loader),
      levelLabelHandler: level => {
        const resolution = Math.min(level.height || 0, level.width || 0);
        const file = this.options.hls.videoFiles.find(f => f.resolution.id === resolution);
        // We don't have files for live videos
        if (!file) return level.height;
        let label = file.resolution.label;
        if (file.fps >= 50) label += file.fps;
        return label;
      }
    };
    return {
      p2pMediaLoader,
      hlsjs
    };
  }
  // ---------------------------------------------------------------------------
  getP2PMediaLoaderOptions(options) {
    var _navigator, _specificLiveOrVODOpt;
    const {
      redundancyUrlManager,
      segmentValidator
    } = options;
    let consumeOnly = false;
    if (((_navigator = navigator) === null || _navigator === void 0 || (_navigator = _navigator.connection) === null || _navigator === void 0 ? void 0 : _navigator.type) === 'cellular' || _root_helpers_peertube_web_storage__WEBPACK_IMPORTED_MODULE_7__.peertubeLocalStorage.getItem('peertube-videojs-p2p-consume-only') === 'true' // Use for E2E testing
    ) {
      _root_helpers_logger__WEBPACK_IMPORTED_MODULE_0__.logger.info('We are on a cellular connection: disabling seeding.');
      consumeOnly = true;
    }
    const trackerAnnounce = this.options.hls.trackerAnnounce.filter(t => t.startsWith('ws'));
    const specificLiveOrVODOptions = this.options.isLive ? this.getP2PMediaLoaderLiveOptions() : this.getP2PMediaLoaderVODOptions();
    return {
      loader: {
        trackerAnnounce,
        rtcConfig: (0,_common__WEBPACK_IMPORTED_MODULE_3__.getRtcConfig)(),
        simultaneousHttpDownloads: 1,
        httpFailedSegmentTimeout: 1000,
        xhrSetup: (xhr, url) => {
          const {
            requiresUserAuth,
            requiresPassword
          } = this.options;
          if (!(requiresUserAuth || requiresPassword)) return;
          if (!(0,_common__WEBPACK_IMPORTED_MODULE_3__.isSameOrigin)(this.options.serverUrl, url)) return;
          if (requiresPassword) xhr.setRequestHeader('x-peertube-video-password', this.options.videoPassword());else xhr.setRequestHeader('Authorization', this.options.authorizationHeader());
        },
        segmentValidator: segmentValidator.validate.bind(segmentValidator),
        segmentUrlBuilder: (0,_p2p_media_loader_segment_url_builder__WEBPACK_IMPORTED_MODULE_5__.segmentUrlBuilderFactory)(redundancyUrlManager),
        useP2P: this.options.p2pEnabled,
        consumeOnly,
        ...specificLiveOrVODOptions
      },
      segments: {
        swarmId: this.options.hls.playlistUrl,
        forwardSegmentCount: (_specificLiveOrVODOpt = specificLiveOrVODOptions.p2pDownloadMaxPriority) !== null && _specificLiveOrVODOpt !== void 0 ? _specificLiveOrVODOpt : 20
      }
    };
  }
  getP2PMediaLoaderLiveOptions() {
    const base = {
      requiredSegmentsPriority: 1
    };
    const latencyMode = this.options.liveOptions.latencyMode;
    switch (latencyMode) {
      case _peertube_peertube_models__WEBPACK_IMPORTED_MODULE_1__.LiveVideoLatencyMode.SMALL_LATENCY:
        return {
          ...base,
          useP2P: false,
          requiredSegmentsPriority: 10
        };
      case _peertube_peertube_models__WEBPACK_IMPORTED_MODULE_1__.LiveVideoLatencyMode.HIGH_LATENCY:
        return base;
      default:
        return base;
    }
  }
  getP2PMediaLoaderVODOptions() {
    return {
      requiredSegmentsPriority: 3,
      skipSegmentBuilderPriority: 1,
      cachedSegmentExpiration: 86400000,
      cachedSegmentsCount: 100,
      httpDownloadMaxPriority: 9,
      httpDownloadProbability: 0.06,
      httpDownloadProbabilitySkipIfNoPeers: true,
      p2pDownloadMaxPriority: 50
    };
  }
  // ---------------------------------------------------------------------------
  getHLSJSOptions(loader) {
    const specificLiveOrVODOptions = this.options.isLive ? this.getHLSLiveOptions() : this.getHLSVODOptions();
    const base = {
      capLevelToPlayerSize: true,
      autoStartLoad: false,
      loader,
      ...specificLiveOrVODOptions
    };
    const averageBandwidth = (0,_peertube_player_local_storage__WEBPACK_IMPORTED_MODULE_2__.getAverageBandwidthInStore)();
    if (!averageBandwidth) return base;
    return {
      ...base,
      abrEwmaDefaultEstimate: averageBandwidth * 8,
      backBufferLength: 90,
      startLevel: -1,
      testBandwidth: false,
      debug: false
    };
  }
  getHLSLiveOptions() {
    const latencyMode = this.options.liveOptions.latencyMode;
    switch (latencyMode) {
      case _peertube_peertube_models__WEBPACK_IMPORTED_MODULE_1__.LiveVideoLatencyMode.SMALL_LATENCY:
        return {
          liveSyncDurationCount: 2
        };
      case _peertube_peertube_models__WEBPACK_IMPORTED_MODULE_1__.LiveVideoLatencyMode.HIGH_LATENCY:
        return {
          liveSyncDurationCount: 10
        };
      default:
        return {
          liveSyncDurationCount: 5
        };
    }
  }
  getHLSVODOptions() {
    return {
      liveSyncDurationCount: 5
    };
  }
}

/***/ }),

/***/ "./src/assets/player/shared/player-options-builder/index.ts":
/*!******************************************************************!*\
  !*** ./src/assets/player/shared/player-options-builder/index.ts ***!
  \******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ControlBarOptionsBuilder: () => (/* reexport safe */ _control_bar_options_builder__WEBPACK_IMPORTED_MODULE_0__.ControlBarOptionsBuilder),
/* harmony export */   HLSOptionsBuilder: () => (/* reexport safe */ _hls_options_builder__WEBPACK_IMPORTED_MODULE_1__.HLSOptionsBuilder),
/* harmony export */   WebVideoOptionsBuilder: () => (/* reexport safe */ _web_video_options_builder__WEBPACK_IMPORTED_MODULE_2__.WebVideoOptionsBuilder)
/* harmony export */ });
/* harmony import */ var _control_bar_options_builder__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./control-bar-options-builder */ "./src/assets/player/shared/player-options-builder/control-bar-options-builder.ts");
/* harmony import */ var _hls_options_builder__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./hls-options-builder */ "./src/assets/player/shared/player-options-builder/hls-options-builder.ts");
/* harmony import */ var _web_video_options_builder__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./web-video-options-builder */ "./src/assets/player/shared/player-options-builder/web-video-options-builder.ts");




/***/ }),

/***/ "./src/assets/player/shared/player-options-builder/web-video-options-builder.ts":
/*!**************************************************************************************!*\
  !*** ./src/assets/player/shared/player-options-builder/web-video-options-builder.ts ***!
  \**************************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   WebVideoOptionsBuilder: () => (/* binding */ WebVideoOptionsBuilder)
/* harmony export */ });
class WebVideoOptionsBuilder {
  constructor(options) {
    this.options = options;
  }
  getPluginOptions() {
    var _this$options$hls;
    return {
      videoFileToken: this.options.videoFileToken,
      videoFiles: this.options.webVideo.videoFiles.length !== 0 ? this.options.webVideo.videoFiles : ((_this$options$hls = this.options.hls) === null || _this$options$hls === void 0 ? void 0 : _this$options$hls.videoFiles) || []
    };
  }
}

/***/ }),

/***/ "./src/assets/player/shared/playlist/playlist-button.ts":
/*!**************************************************************!*\
  !*** ./src/assets/player/shared/playlist/playlist-button.ts ***!
  \**************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PlaylistButton: () => (/* binding */ PlaylistButton)
/* harmony export */ });
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);

const ClickableComponent = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('ClickableComponent');
class PlaylistButton extends ClickableComponent {
  // FIXME: eslint -> it's not a useless constructor, we need to extend constructor options typings
  // eslint-disable-next-line @typescript-eslint/no-useless-constructor
  constructor(player, options) {
    super(player, options);
  }
  createEl() {
    this.wrapper = super.createEl('div', {
      className: 'vjs-playlist-button',
      tabIndex: -1
    });
    const icon = super.createEl('div', {
      className: 'vjs-playlist-icon',
      tabIndex: -1
    });
    this.playlistInfoElement = super.createEl('div', {
      className: 'vjs-playlist-info',
      tabIndex: -1
    });
    this.wrapper.appendChild(icon);
    this.wrapper.appendChild(this.playlistInfoElement);
    this.update();
    return this.wrapper;
  }
  update() {
    this.playlistInfoElement.innerText = this.options_.getCurrentPosition() + '/' + this.options_.playlist.videosLength;
    this.wrapper.title = this.player().localize('Playlist: {1}', [this.options_.playlist.displayName]);
  }
  handleClick() {
    const playlistMenu = this.options_.playlistMenu;
    playlistMenu.open();
  }
}
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerComponent('PlaylistButton', PlaylistButton);


/***/ }),

/***/ "./src/assets/player/shared/playlist/playlist-menu-item.ts":
/*!*****************************************************************!*\
  !*** ./src/assets/player/shared/playlist/playlist-menu-item.ts ***!
  \*****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PlaylistMenuItem: () => (/* binding */ PlaylistMenuItem)
/* harmony export */ });
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @peertube/peertube-core-utils */ "../packages/core-utils/dist/index.js");


const Component = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('Component');
class PlaylistMenuItem extends Component {
  constructor(player, options) {
    super(player, options);
    this.emitTapEvents();
    this.element = options.element;
    this.clickHandler = () => this.switchPlaylistItem();
    this.keyDownHandler = event => this.handleKeyDown(event);
    this.on(['click', 'tap'], this.clickHandler);
    this.on('keydown', this.keyDownHandler);
  }
  dispose() {
    this.off(['click', 'tap'], this.clickHandler);
    this.off('keydown', this.keyDownHandler);
    super.dispose();
  }
  createEl() {
    const li = super.createEl('li', {
      className: 'vjs-playlist-menu-item'
    });
    if (!this.options_.element.video) {
      li.classList.add('vjs-disabled');
    }
    const positionBlock = super.createEl('div', {
      className: 'item-position-block'
    });
    const position = super.createEl('div', {
      className: 'item-position',
      innerText: this.options_.element.position
    });
    positionBlock.appendChild(position);
    li.appendChild(positionBlock);
    if (this.options_.element.video) {
      this.buildAvailableVideo(li, positionBlock, this.options_);
    } else {
      this.buildUnavailableVideo(li);
    }
    return li;
  }
  setSelected(selected) {
    if (selected) this.addClass('vjs-selected');else this.removeClass('vjs-selected');
  }
  getElement() {
    return this.element;
  }
  buildAvailableVideo(li, positionBlock, options) {
    const videoElement = options.element;
    const player = super.createEl('div', {
      className: 'item-player'
    });
    positionBlock.appendChild(player);
    const thumbnail = super.createEl('img', {
      src: window.location.origin + videoElement.video.thumbnailPath
    });
    const infoBlock = super.createEl('div', {
      className: 'info-block'
    });
    const title = super.createEl('div', {
      innerText: videoElement.video.name,
      className: 'title'
    });
    const channel = super.createEl('div', {
      innerText: videoElement.video.channel.displayName,
      className: 'channel'
    });
    infoBlock.appendChild(title);
    infoBlock.appendChild(channel);
    if (videoElement.startTimestamp || videoElement.stopTimestamp) {
      let html = '';
      if (videoElement.startTimestamp) html += (0,_peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_1__.secondsToTime)(videoElement.startTimestamp);
      if (videoElement.stopTimestamp) html += ' - ' + (0,_peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_1__.secondsToTime)(videoElement.stopTimestamp);
      const timestamps = super.createEl('div', {
        innerText: html,
        className: 'timestamps'
      });
      infoBlock.append(timestamps);
    }
    li.append(thumbnail);
    li.append(infoBlock);
  }
  buildUnavailableVideo(li) {
    const block = super.createEl('div', {
      className: 'item-unavailable',
      innerText: this.player().localize('Unavailable video')
    });
    li.appendChild(block);
  }
  handleKeyDown(event) {
    if (event.code === 'Space' || event.code === 'Enter') {
      this.switchPlaylistItem();
    }
  }
  switchPlaylistItem() {
    this.options_.onClicked();
  }
}
Component.registerComponent('PlaylistMenuItem', PlaylistMenuItem);


/***/ }),

/***/ "./src/assets/player/shared/playlist/playlist-menu.ts":
/*!************************************************************!*\
  !*** ./src/assets/player/shared/playlist/playlist-menu.ts ***!
  \************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PlaylistMenu: () => (/* binding */ PlaylistMenu)
/* harmony export */ });
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _playlist_menu_item__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./playlist-menu-item */ "./src/assets/player/shared/playlist/playlist-menu-item.ts");


const Component = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('Component');
class PlaylistMenu extends Component {
  constructor(player, options) {
    super(player, options);
    this.menuItems = [];
    this.userInactiveHandler = () => {
      this.close();
    };
    this.onMouseEnter = () => {
      this.player().off('userinactive', this.userInactiveHandler);
    };
    this.onMouseLeave = () => {
      this.player().one('userinactive', this.userInactiveHandler);
    };
    this.onPlayerCick = event => {
      let current = event.target;
      do {
        if (current.classList.contains('vjs-playlist-menu') || current.classList.contains('vjs-playlist-button')) {
          return;
        }
        current = current.parentElement;
      } while (current);
      this.close();
    };
    this.el().addEventListener('mouseenter', this.onMouseEnter);
    this.el().addEventListener('mouseleave', this.onMouseLeave);
    this.player().on('click', this.onPlayerCick);
  }
  dispose() {
    this.el().removeEventListener('mouseenter', this.onMouseEnter);
    this.el().removeEventListener('mouseleave', this.onMouseLeave);
    this.player().off('userinactive', this.userInactiveHandler);
    this.player().off('click', this.onPlayerCick);
    for (const item of this.menuItems) {
      item.dispose();
    }
    super.dispose();
  }
  createEl() {
    this.menuItems = [];
    const menu = super.createEl('div', {
      className: 'vjs-playlist-menu',
      tabIndex: -1
    });
    const header = super.createEl('div', {
      className: 'header'
    });
    const headerLeft = super.createEl('div');
    const leftTitle = super.createEl('div', {
      innerText: this.options_.playlist.displayName,
      className: 'title'
    });
    const playlistChannel = this.options_.playlist.videoChannel;
    const leftSubtitle = super.createEl('div', {
      innerText: playlistChannel ? this.player().localize('By {1}', [playlistChannel.displayName]) : '',
      className: 'channel'
    });
    headerLeft.appendChild(leftTitle);
    headerLeft.appendChild(leftSubtitle);
    const tick = super.createEl('div', {
      className: 'cross'
    });
    tick.addEventListener('click', () => this.close());
    header.appendChild(headerLeft);
    header.appendChild(tick);
    const list = super.createEl('ol');
    for (const playlistElement of this.options_.elements) {
      const item = new _playlist_menu_item__WEBPACK_IMPORTED_MODULE_1__.PlaylistMenuItem(this.player(), {
        element: playlistElement,
        onClicked: () => this.onItemClicked(playlistElement)
      });
      list.appendChild(item.el());
      this.menuItems.push(item);
    }
    menu.appendChild(header);
    menu.appendChild(list);
    this.update();
    return menu;
  }
  update() {
    this.updateSelected(this.options_.getCurrentPosition());
  }
  open() {
    this.player().addClass('playlist-menu-displayed');
  }
  close() {
    this.player().removeClass('playlist-menu-displayed');
  }
  updateSelected(newPosition) {
    for (const item of this.menuItems) {
      item.setSelected(item.getElement().position === newPosition);
    }
  }
  onItemClicked(element) {
    this.options_.onItemClicked(element);
  }
}
Component.registerComponent('PlaylistMenu', PlaylistMenu);


/***/ }),

/***/ "./src/assets/player/shared/playlist/playlist-plugin.ts":
/*!**************************************************************!*\
  !*** ./src/assets/player/shared/playlist/playlist-plugin.ts ***!
  \**************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PlaylistPlugin: () => (/* binding */ PlaylistPlugin)
/* harmony export */ });
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _playlist_button__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./playlist-button */ "./src/assets/player/shared/playlist/playlist-button.ts");
/* harmony import */ var _playlist_menu__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./playlist-menu */ "./src/assets/player/shared/playlist/playlist-menu.ts");



const Plugin = video_js__WEBPACK_IMPORTED_MODULE_0___default().getPlugin('plugin');
class PlaylistPlugin extends Plugin {
  constructor(player, options) {
    super(player, options);
    this.playlistMenu = new _playlist_menu__WEBPACK_IMPORTED_MODULE_2__.PlaylistMenu(player, options);
    this.playlistButton = new _playlist_button__WEBPACK_IMPORTED_MODULE_1__.PlaylistButton(player, {
      ...options,
      playlistMenu: this.playlistMenu
    });
    player.addChild(this.playlistMenu, options);
    player.addChild(this.playlistButton, options);
  }
  dispose() {
    this.player.removeClass('vjs-playlist');
    this.playlistMenu.dispose();
    this.playlistButton.dispose();
    this.player.removeChild(this.playlistMenu);
    this.player.removeChild(this.playlistButton);
    super.dispose();
  }
}
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerPlugin('playlist', PlaylistPlugin);


/***/ }),

/***/ "./src/assets/player/shared/resolutions/peertube-resolutions-plugin.ts":
/*!*****************************************************************************!*\
  !*** ./src/assets/player/shared/resolutions/peertube-resolutions-plugin.ts ***!
  \*****************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PeerTubeResolutionsPlugin: () => (/* binding */ PeerTubeResolutionsPlugin)
/* harmony export */ });
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);

const Plugin = video_js__WEBPACK_IMPORTED_MODULE_0___default().getPlugin('plugin');
class PeerTubeResolutionsPlugin extends Plugin {
  constructor(player) {
    super(player);
    this.resolutions = [];
    player.on('video-change', () => {
      this.resolutions = [];
      this.trigger('resolutions-removed');
    });
  }
  add(resolutions) {
    for (const r of resolutions) {
      this.resolutions.push(r);
    }
    this.currentSelection = this.getSelected();
    this.sort();
    this.trigger('resolutions-added');
  }
  remove(resolutionIndex) {
    this.resolutions = this.resolutions.filter(r => r.id !== resolutionIndex);
    this.trigger('resolutions-removed');
  }
  getResolutions() {
    return this.resolutions;
  }
  getSelected() {
    return this.resolutions.find(r => r.selected);
  }
  getAutoResolutionChosen() {
    return this.resolutions.find(r => r.id === this.autoResolutionChosenId);
  }
  select(options) {
    var _this$currentSelectio;
    const {
      id,
      autoResolutionChosenId,
      fireCallback
    } = options;
    if (((_this$currentSelectio = this.currentSelection) === null || _this$currentSelectio === void 0 ? void 0 : _this$currentSelectio.id) === id && this.autoResolutionChosenId === autoResolutionChosenId) return;
    this.autoResolutionChosenId = autoResolutionChosenId;
    for (const r of this.resolutions) {
      r.selected = r.id === id;
      if (r.selected) {
        this.currentSelection = r;
        if (fireCallback) r.selectCallback();
      }
    }
    this.trigger('resolutions-changed');
  }
  sort() {
    this.resolutions.sort((a, b) => {
      if (a.id === -1) return 1;
      if (b.id === -1) return -1;
      if (a.height > b.height) return -1;
      if (a.height === b.height) return 0;
      return 1;
    });
  }
}
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerPlugin('peertubeResolutions', PeerTubeResolutionsPlugin);


/***/ }),

/***/ "./src/assets/player/shared/settings/resolution-menu-button.ts":
/*!*********************************************************************!*\
  !*** ./src/assets/player/shared/settings/resolution-menu-button.ts ***!
  \*********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _resolution_menu_item__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./resolution-menu-item */ "./src/assets/player/shared/settings/resolution-menu-item.ts");


const Menu = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('Menu');
const MenuButton = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('MenuButton');
class ResolutionMenuButton extends MenuButton {
  constructor(player, options) {
    super(player, options);
    this.controlText('Quality');
    player.peertubeResolutions().on('resolutions-added', () => this.update());
    player.peertubeResolutions().on('resolutions-removed', () => this.update());
    // For parent
    player.peertubeResolutions().on('resolutions-changed', () => {
      setTimeout(() => this.trigger('label-updated'));
    });
  }
  createEl() {
    const el = super.createEl();
    this.labelEl_ = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('div', {
      className: 'vjs-resolution-value'
    });
    el.appendChild(this.labelEl_);
    return el;
  }
  updateARIAAttributes() {
    this.el().setAttribute('aria-label', 'Quality');
  }
  createMenu() {
    const menu = new Menu(this.player_, {
      menuButton: this
    });
    const resolutions = this.player().peertubeResolutions().getResolutions();
    for (const r of resolutions) {
      const label = r.label === '0p' ? this.player().localize('Audio-only') : r.label;
      const component = new _resolution_menu_item__WEBPACK_IMPORTED_MODULE_1__.ResolutionMenuItem(this.player_, {
        id: r.id + '',
        resolutionId: r.id,
        label,
        selected: r.selected
      });
      menu.addItem(component);
    }
    return menu;
  }
  update() {
    super.update();
    this.trigger('resolution-menu-changed');
  }
  buildCSSClass() {
    return 'vjs-resolution-button ' + super.buildCSSClass();
  }
  buildWrapperCSSClass() {
    return 'vjs-resolution-control ' + super.buildWrapperCSSClass();
  }
}
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerComponent('ResolutionMenuButton', ResolutionMenuButton);

/***/ }),

/***/ "./src/assets/player/shared/settings/resolution-menu-item.ts":
/*!*******************************************************************!*\
  !*** ./src/assets/player/shared/settings/resolution-menu-item.ts ***!
  \*******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ResolutionMenuItem: () => (/* binding */ ResolutionMenuItem)
/* harmony export */ });
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);

const MenuItem = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('MenuItem');
class ResolutionMenuItem extends MenuItem {
  constructor(player, options) {
    super(player, {
      ...options,
      selectable: true
    });
    this.autoResolutionChosen = '';
    this.resolutionId = options.resolutionId;
    this.label = options.label;
    this.updateSelectionHandler = () => this.updateSelection();
    player.peertubeResolutions().on('resolutions-changed', this.updateSelectionHandler);
  }
  dispose() {
    this.player().peertubeResolutions().off('resolutions-changed', this.updateSelectionHandler);
    super.dispose();
  }
  handleClick(event) {
    super.handleClick(event);
    this.player().peertubeResolutions().select({
      id: this.resolutionId,
      fireCallback: true
    });
  }
  updateSelection() {
    const selectedResolution = this.player().peertubeResolutions().getSelected();
    if (this.resolutionId === -1) {
      var _this$player$peertube;
      this.autoResolutionChosen = (_this$player$peertube = this.player().peertubeResolutions().getAutoResolutionChosen()) === null || _this$player$peertube === void 0 ? void 0 : _this$player$peertube.label;
    }
    this.selected(this.resolutionId === selectedResolution.id);
  }
  getLabel() {
    if (this.resolutionId === -1) {
      return this.label + ' <small>' + this.autoResolutionChosen + '</small>';
    }
    return this.label;
  }
}
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerComponent('ResolutionMenuItem', ResolutionMenuItem);


/***/ }),

/***/ "./src/assets/player/shared/settings/settings-dialog.ts":
/*!**************************************************************!*\
  !*** ./src/assets/player/shared/settings/settings-dialog.ts ***!
  \**************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   SettingsDialog: () => (/* binding */ SettingsDialog)
/* harmony export */ });
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);

const Component = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('Component');
class SettingsDialog extends Component {
  constructor(player) {
    super(player);
    this.hide();
  }
  /**
   * Create the component's DOM element
   *
   */
  createEl() {
    const uniqueId = this.id();
    const dialogLabelId = 'TTsettingsDialogLabel-' + uniqueId;
    const dialogDescriptionId = 'TTsettingsDialogDescription-' + uniqueId;
    return super.createEl('div', {
      className: 'vjs-settings-dialog vjs-modal-overlay',
      tabIndex: -1
    }, {
      'role': 'dialog',
      'aria-labelledby': dialogLabelId,
      'aria-describedby': dialogDescriptionId
    });
  }
  show() {
    this.player().addClass('vjs-settings-dialog-opened');
    super.show();
  }
  hide() {
    this.player().removeClass('vjs-settings-dialog-opened');
    super.hide();
  }
}
Component.registerComponent('SettingsDialog', SettingsDialog);


/***/ }),

/***/ "./src/assets/player/shared/settings/settings-menu-button.ts":
/*!*******************************************************************!*\
  !*** ./src/assets/player/shared/settings/settings-menu-button.ts ***!
  \*******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   SettingsButton: () => (/* binding */ SettingsButton)
/* harmony export */ });
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _common__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../common */ "./src/assets/player/shared/common/index.ts");
/* harmony import */ var _settings_menu_item__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./settings-menu-item */ "./src/assets/player/shared/settings/settings-menu-item.ts");



const Button = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('Button');
const Menu = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('Menu');
const Component = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('Component');
class SettingsButton extends Button {
  constructor(player, options) {
    super(player, options);
    this.settingsButtonOptions = options;
    this.controlText('Settings');
    this.dialog = this.player().addChild('settingsDialog');
    this.dialogEl = this.dialog.el();
    this.menu = null;
    this.panel = this.dialog.addChild('settingsPanel');
    this.panelChild = this.panel.addChild('settingsPanelChild');
    this.addClass('vjs-settings');
    this.el().setAttribute('aria-label', 'Settings Button');
    // Event handlers
    this.addSettingsItemHandler = this.onAddSettingsItem.bind(this);
    this.disposeSettingsItemHandler = this.onDisposeSettingsItem.bind(this);
    this.documentClickHandler = this.onDocumentClick.bind(this);
    this.userInactiveHandler = this.onUserInactive.bind(this);
    this.buildMenu();
    this.bindEvents();
    // Prepare the dialog
    this.player().one('play', () => this.hideDialog());
  }
  onDocumentClick(event) {
    var _element$classList, _element$parentElemen;
    const element = event.target;
    if (element !== null && element !== void 0 && (_element$classList = element.classList) !== null && _element$classList !== void 0 && _element$classList.contains('vjs-settings') || element !== null && element !== void 0 && (_element$parentElemen = element.parentElement) !== null && _element$parentElemen !== void 0 && (_element$parentElemen = _element$parentElemen.classList) !== null && _element$parentElemen !== void 0 && _element$parentElemen.contains('vjs-settings')) {
      return;
    }
    if (!this.dialog.hasClass('vjs-hidden')) {
      this.hideDialog();
    }
  }
  onDisposeSettingsItem(_event, name) {
    if (name === undefined) {
      const children = this.menu.children();
      while (children.length > 0) {
        children[0].dispose();
        this.menu.removeChild(children[0]);
      }
      this.addClass('vjs-hidden');
    } else {
      const item = this.menu.getChild(name);
      if (item) {
        item.dispose();
        this.menu.removeChild(item);
      }
    }
    this.hideDialog();
    if (this.settingsButtonOptions.entries.length === 0) {
      this.addClass('vjs-hidden');
    }
  }
  dispose() {
    document.removeEventListener('click', this.documentClickHandler);
    if (this.isInIframe()) {
      window.removeEventListener('blur', this.documentClickHandler);
    }
    super.dispose();
  }
  onAddSettingsItem(event, data) {
    const [entry, options] = data;
    this.addMenuItem(entry, options);
    this.removeClass('vjs-hidden');
  }
  onUserInactive() {
    if (!this.dialog.hasClass('vjs-hidden')) {
      this.hideDialog();
    }
  }
  bindEvents() {
    document.addEventListener('click', this.documentClickHandler);
    if (this.isInIframe()) {
      window.addEventListener('blur', this.documentClickHandler);
    }
    this.player().on('addsettingsitem', this.addSettingsItemHandler);
    this.player().on('disposesettingsitem', this.disposeSettingsItemHandler);
    this.player().on('userinactive', this.userInactiveHandler);
  }
  buildCSSClass() {
    return "vjs-icon-settings ".concat(super.buildCSSClass());
  }
  handleClick() {
    if (this.dialog.hasClass('vjs-hidden')) {
      this.showDialog();
    } else {
      this.hideDialog();
    }
  }
  showDialog() {
    this.player().peertube().onMenuOpened();
    this.menu.el().style.opacity = '1';
    this.dialog.show();
    this.el().setAttribute('aria-expanded', 'true');
    this.setDialogSize(this.getComponentSize(this.menu));
    const firstChild = this.menu.children()[0];
    if (firstChild) firstChild.focus();
  }
  hideDialog() {
    this.player_.peertube().onMenuClosed();
    this.dialog.hide();
    this.el().setAttribute('aria-expanded', 'false');
    this.setDialogSize(this.getComponentSize(this.menu));
    this.menu.el().style.opacity = '1';
    this.resetChildren();
  }
  getComponentSize(element) {
    let width = null;
    let height = null;
    // Could be component or just DOM element
    if (element instanceof Component) {
      const el = element.el();
      width = el.offsetWidth;
      height = el.offsetHeight;
    } else {
      width = element.offsetWidth;
      height = element.offsetHeight;
    }
    return [width, height];
  }
  setDialogSize(_ref) {
    let [width, height] = _ref;
    if (typeof height !== 'number') {
      return;
    }
    const offset = this.settingsButtonOptions.setup.maxHeightOffset;
    const maxHeight = this.player().el().offsetHeight - offset;
    const panelEl = this.panel.el();
    if (height > maxHeight) {
      height = maxHeight;
      width += 15;
      panelEl.style.maxHeight = "".concat(height, "px");
    } else if (panelEl.style.maxHeight !== '') {
      panelEl.style.maxHeight = '';
    }
    this.dialogEl.style.width = "".concat(width, "px");
    this.dialogEl.style.height = "".concat(height, "px");
  }
  buildMenu() {
    this.menu = new Menu(this.player());
    this.menu.addClass('vjs-main-menu');
    const entries = this.settingsButtonOptions.entries;
    if (entries.length === 0) {
      this.addClass('vjs-hidden');
      this.panelChild.addChild(this.menu);
      return;
    }
    for (const entry of entries) {
      this.addMenuItem(entry, this.settingsButtonOptions);
    }
    this.panelChild.addChild(this.menu);
  }
  addMenuItem(entry, options) {
    const openSubMenu = function () {
      if (video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.hasClass(this.el_, 'open')) {
        video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.removeClass(this.el_, 'open');
      } else {
        video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.addClass(this.el_, 'open');
      }
    };
    options.name = (0,_common__WEBPACK_IMPORTED_MODULE_1__.toTitleCase)(entry);
    const newOptions = Object.assign({}, options, {
      entry,
      menuButton: this
    });
    const settingsMenuItem = new _settings_menu_item__WEBPACK_IMPORTED_MODULE_2__.SettingsMenuItem(this.player(), newOptions);
    this.menu.addChild(settingsMenuItem);
    // Hide children to avoid sub menus stacking on top of each other
    // or having multiple menus open
    // eslint-disable-next-line @typescript-eslint/unbound-method
    settingsMenuItem.on('click', video_js__WEBPACK_IMPORTED_MODULE_0___default().bind(this, this.hideChildren));
    // Whether to add or remove selected class on the settings sub menu element
    settingsMenuItem.on('click', openSubMenu);
  }
  resetChildren() {
    for (const menuChild of this.menu.children()) {
      menuChild.reset();
    }
  }
  /**
   * Hide all the sub menus
   */
  hideChildren() {
    for (const menuChild of this.menu.children()) {
      menuChild.hideSubMenu();
    }
  }
  isInIframe() {
    return window.self !== window.top;
  }
}
Component.registerComponent('SettingsButton', SettingsButton);


/***/ }),

/***/ "./src/assets/player/shared/settings/settings-menu-item.ts":
/*!*****************************************************************!*\
  !*** ./src/assets/player/shared/settings/settings-menu-item.ts ***!
  \*****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   SettingsMenuItem: () => (/* binding */ SettingsMenuItem)
/* harmony export */ });
/* harmony import */ var debug__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! debug */ "./node_modules/debug/src/browser.js");
/* harmony import */ var debug__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(debug__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _common__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../common */ "./src/assets/player/shared/common/index.ts");



const debugLogger = debug__WEBPACK_IMPORTED_MODULE_0___default()('peertube:player:settings');
const MenuItem = video_js__WEBPACK_IMPORTED_MODULE_1___default().getComponent('MenuItem');
const Component = video_js__WEBPACK_IMPORTED_MODULE_1___default().getComponent('Component');
class SettingsMenuItem extends MenuItem {
  constructor(player, options) {
    super(player, options);
    this.settingsButton = options.menuButton;
    this.dialog = this.settingsButton.dialog;
    this.mainMenu = this.settingsButton.menu;
    this.panel = this.dialog.getChild('settingsPanel');
    this.panelChild = this.panel.getChild('settingsPanelChild');
    this.panelChildEl = this.panelChild.el();
    this.size = null;
    // keep state of what menu type is loading next
    this.menuToLoad = 'mainmenu';
    const subMenuName = (0,_common__WEBPACK_IMPORTED_MODULE_2__.toTitleCase)(options.entry);
    const SubMenuComponent = video_js__WEBPACK_IMPORTED_MODULE_1___default().getComponent(subMenuName);
    if (!SubMenuComponent) {
      throw new Error("Component ".concat(subMenuName, " does not exist"));
    }
    const newOptions = Object.assign({}, options, {
      entry: options.menuButton,
      menuButton: this
    });
    this.subMenu = new SubMenuComponent(this.player(), newOptions);
    const subMenuClass = this.subMenu.buildCSSClass().split(' ')[0];
    this.settingsSubMenuEl_.className += ' ' + subMenuClass;
    this.eventHandlers();
    player.ready(() => {
      // Voodoo magic for IOS
      setTimeout(() => {
        // Player was destroyed
        if (!this.player_) return;
        this.build();
        // Update on rate change
        if (subMenuName === 'PlaybackRateMenuButton') {
          player.on('ratechange', this.submenuClickHandler);
        }
        if (subMenuName === 'CaptionsButton') {
          player.on('captions-changed', () => {
            setTimeout(() => this.rebuildAfterMenuChange());
          });
          // Needed because 'captions-changed' event doesn't contain the selected caption yet
          player.on('texttrackchange', this.submenuClickHandler);
        }
        if (subMenuName === 'ResolutionMenuButton') {
          this.subMenu.on('resolution-menu-changed', () => {
            this.rebuildAfterMenuChange();
          });
        }
        this.reset();
      }, 0);
    });
  }
  dispose() {
    this.settingsSubMenuEl_.removeEventListener('transitionend', this.transitionEndHandler);
    super.dispose();
  }
  eventHandlers() {
    this.submenuClickHandler = this.onSubmenuClick.bind(this);
    this.transitionEndHandler = this.onTransitionEnd.bind(this);
  }
  onSubmenuClick(event) {
    var _target;
    let target = null;
    if (event.type === 'tap') {
      target = event.target;
    } else {
      target = event.currentTarget || event.target;
    }
    if ((_target = target) !== null && _target !== void 0 && _target.classList.contains('vjs-back-button')) {
      this.loadMainMenu();
      return;
    }
    // To update the sub menu value on click, setTimeout is needed because
    // updating the value is not instant
    setTimeout(() => this.update(event), 0);
    // Seems like videojs adds a vjs-hidden class on the caption menu after a click
    // We don't need it
    this.subMenu.menu.removeClass('vjs-hidden');
  }
  /**
   * Create the component's DOM element
   *
   */
  createEl() {
    const el = video_js__WEBPACK_IMPORTED_MODULE_1___default().dom.createEl('li', {
      className: 'vjs-menu-item',
      tabIndex: -1
    });
    this.settingsSubMenuTitleEl_ = video_js__WEBPACK_IMPORTED_MODULE_1___default().dom.createEl('div', {
      className: 'vjs-settings-sub-menu-title'
    });
    el.appendChild(this.settingsSubMenuTitleEl_);
    this.settingsSubMenuValueEl_ = video_js__WEBPACK_IMPORTED_MODULE_1___default().dom.createEl('div', {
      className: 'vjs-settings-sub-menu-value'
    });
    el.appendChild(this.settingsSubMenuValueEl_);
    this.settingsSubMenuEl_ = video_js__WEBPACK_IMPORTED_MODULE_1___default().dom.createEl('div', {
      className: 'vjs-settings-sub-menu'
    });
    return el;
  }
  /**
   * Handle click on menu item
   *
   * @method handleClick
   */
  handleClick(event) {
    this.menuToLoad = 'submenu';
    // Remove open class to ensure only the open submenu gets this class
    video_js__WEBPACK_IMPORTED_MODULE_1___default().dom.removeClass(this.el(), 'open');
    super.handleClick(event);
    this.mainMenu.el().style.opacity = '0';
    // Whether to add or remove vjs-hidden class on the settingsSubMenuEl element
    if (video_js__WEBPACK_IMPORTED_MODULE_1___default().dom.hasClass(this.settingsSubMenuEl_, 'vjs-hidden')) {
      video_js__WEBPACK_IMPORTED_MODULE_1___default().dom.removeClass(this.settingsSubMenuEl_, 'vjs-hidden');
      // animation not played without timeout
      setTimeout(() => {
        this.settingsSubMenuEl_.style.opacity = '1';
        this.settingsSubMenuEl_.style.marginRight = '0px';
      }, 0);
      this.settingsButton.setDialogSize(this.size);
      const firstChild = this.subMenu.menu.children()[0];
      if (firstChild) firstChild.focus();
    } else {
      video_js__WEBPACK_IMPORTED_MODULE_1___default().dom.addClass(this.settingsSubMenuEl_, 'vjs-hidden');
    }
  }
  /**
   * Create back button
   *
   * @method createBackButton
   */
  createBackButton() {
    const button = this.subMenu.menu.addChild('MenuItem', {}, 0);
    button.addClass('vjs-back-button');
    button.el().innerHTML = this.player().localize(this.subMenu.controlText());
  }
  onTransitionEnd(event) {
    if (event.propertyName !== 'margin-right') {
      return;
    }
    if (this.menuToLoad === 'mainmenu') {
      // hide submenu
      video_js__WEBPACK_IMPORTED_MODULE_1___default().dom.addClass(this.settingsSubMenuEl_, 'vjs-hidden');
      // reset opacity to 0
      this.settingsSubMenuEl_.style.opacity = '0';
    }
  }
  reset() {
    video_js__WEBPACK_IMPORTED_MODULE_1___default().dom.addClass(this.settingsSubMenuEl_, 'vjs-hidden');
    this.settingsSubMenuEl_.style.opacity = '0';
    this.setMargin();
  }
  loadMainMenu() {
    const mainMenuEl = this.mainMenu.el();
    this.menuToLoad = 'mainmenu';
    this.mainMenu.show();
    mainMenuEl.style.opacity = '0';
    // back button will always take you to main menu, so set dialog sizes
    const mainMenuAny = this.mainMenu;
    this.settingsButton.setDialogSize([mainMenuAny.width(), mainMenuAny.height()]);
    // animation not triggered without timeout (some async stuff ?!?)
    setTimeout(() => {
      // animate margin and opacity before hiding the submenu
      // this triggers CSS Transition event
      this.setMargin();
      mainMenuEl.style.opacity = '1';
      const firstChild = this.mainMenu.children()[0];
      if (firstChild) firstChild.focus();
    }, 0);
  }
  build() {
    this.subMenu.on('label-updated', () => {
      this.update();
    });
    this.settingsSubMenuTitleEl_.innerHTML = this.player().localize(this.subMenu.controlText());
    this.settingsSubMenuEl_.appendChild(this.subMenu.menu.el());
    this.panelChildEl.appendChild(this.settingsSubMenuEl_);
    this.update();
    this.createBackButton();
    this.setSize();
    this.bindClickEvents();
    this.settingsSubMenuEl_.addEventListener('transitionend', this.transitionEndHandler, false);
  }
  update(event) {
    // Playback rate menu button doesn't get a vjs-selected class
    // or sets options_['selected'] on the selected playback rate.
    // Thus we get the submenu value based on the labelEl of playbackRateMenuButton
    if (this.subMenu.name() === 'PlaybackRateMenuButton') {
      this.settingsSubMenuValueEl_.innerHTML = this.subMenu.labelEl_.textContent;
    } else {
      // Loop through the submenu items to find the selected child
      for (const subMenuItem of this.subMenu.menu.children_) {
        if (!(subMenuItem instanceof MenuItem)) {
          continue;
        }
        const subMenuItemExtended = subMenuItem;
        if (subMenuItemExtended.isSelected_) {
          // Prefer to use the function
          if (typeof subMenuItemExtended.getLabel === 'function') {
            this.settingsSubMenuValueEl_.innerHTML = subMenuItemExtended.getLabel();
            break;
          }
          this.settingsSubMenuValueEl_.innerHTML = this.player().localize(subMenuItemExtended.options_.label);
        }
      }
    }
    let target = null;
    if (event && event.type === 'tap') {
      target = event.target;
    } else if (event) {
      target = event.currentTarget;
    }
    if (target && !target.classList.contains('vjs-back-button')) {
      this.settingsButton.hideDialog();
    }
  }
  bindClickEvents() {
    for (const item of this.subMenu.menu.children()) {
      if (!(item instanceof Component)) {
        continue;
      }
      item.on(['tap', 'click'], this.submenuClickHandler);
    }
  }
  // save size of submenus on first init
  // if number of submenu items change dynamically more logic will be needed
  setSize() {
    this.dialog.removeClass('vjs-hidden');
    video_js__WEBPACK_IMPORTED_MODULE_1___default().dom.removeClass(this.settingsSubMenuEl_, 'vjs-hidden');
    this.size = this.settingsButton.getComponentSize(this.settingsSubMenuEl_);
    this.setMargin();
    this.dialog.addClass('vjs-hidden');
    video_js__WEBPACK_IMPORTED_MODULE_1___default().dom.addClass(this.settingsSubMenuEl_, 'vjs-hidden');
  }
  setMargin() {
    if (!this.size) return;
    const [width] = this.size;
    this.settingsSubMenuEl_.style.marginRight = "-".concat(width, "px");
  }
  /**
   * Hide the sub menu
   */
  hideSubMenu() {
    // after removing settings item this.el_ === null
    if (!this.el()) {
      return;
    }
    if (video_js__WEBPACK_IMPORTED_MODULE_1___default().dom.hasClass(this.el(), 'open')) {
      video_js__WEBPACK_IMPORTED_MODULE_1___default().dom.addClass(this.settingsSubMenuEl_, 'vjs-hidden');
      video_js__WEBPACK_IMPORTED_MODULE_1___default().dom.removeClass(this.el(), 'open');
    }
  }
  rebuildAfterMenuChange() {
    debugLogger('Rebuilding menu ' + this.subMenu.name() + ' after change');
    this.settingsSubMenuEl_.innerHTML = '';
    this.settingsSubMenuEl_.appendChild(this.subMenu.menu.el());
    this.update();
    this.createBackButton();
    this.setSize();
    this.bindClickEvents();
  }
}
SettingsMenuItem.prototype.contentElType = 'button';
video_js__WEBPACK_IMPORTED_MODULE_1___default().registerComponent('SettingsMenuItem', SettingsMenuItem);


/***/ }),

/***/ "./src/assets/player/shared/settings/settings-panel-child.ts":
/*!*******************************************************************!*\
  !*** ./src/assets/player/shared/settings/settings-panel-child.ts ***!
  \*******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   SettingsPanelChild: () => (/* binding */ SettingsPanelChild)
/* harmony export */ });
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);

const Component = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('Component');
class SettingsPanelChild extends Component {
  createEl() {
    return super.createEl('div', {
      className: 'vjs-settings-panel-child',
      tabIndex: -1
    });
  }
}
Component.registerComponent('SettingsPanelChild', SettingsPanelChild);


/***/ }),

/***/ "./src/assets/player/shared/settings/settings-panel.ts":
/*!*************************************************************!*\
  !*** ./src/assets/player/shared/settings/settings-panel.ts ***!
  \*************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   SettingsPanel: () => (/* binding */ SettingsPanel)
/* harmony export */ });
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);

const Component = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('Component');
class SettingsPanel extends Component {
  createEl() {
    return super.createEl('div', {
      className: 'vjs-settings-panel',
      tabIndex: -1
    });
  }
}
Component.registerComponent('SettingsPanel', SettingsPanel);


/***/ }),

/***/ "./src/assets/player/shared/stats/stats-card.ts":
/*!******************************************************!*\
  !*** ./src/assets/player/shared/stats/stats-card.ts ***!
  \******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   StatsCard: () => (/* binding */ StatsCard)
/* harmony export */ });
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _root_helpers_logger__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @root-helpers/logger */ "./src/root-helpers/logger.ts");
/* harmony import */ var _peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @peertube/peertube-core-utils */ "../packages/core-utils/dist/index.js");
/* harmony import */ var _common__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../common */ "./src/assets/player/shared/common/index.ts");




const Component = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('Component');
class StatsCard extends Component {
  constructor() {
    super(...arguments);
    this.metadataStore = {};
    this.intervalMs = 300;
    this.playerNetworkInfo = {};
  }
  createEl() {
    this.containerEl = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('div', {
      className: 'vjs-stats-content'
    });
    this.containerEl.style.display = 'none';
    this.infoListEl = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('div', {
      className: 'vjs-stats-list'
    });
    const closeButton = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('button', {
      className: 'vjs-stats-close',
      tabindex: '0',
      title: 'Close stats',
      innerText: '[x]'
    }, {
      'aria-label': 'Close stats'
    });
    closeButton.onclick = () => this.hide();
    this.containerEl.appendChild(closeButton);
    this.containerEl.appendChild(this.infoListEl);
    this.populateInfoBlocks();
    this.onNetworkInfoHandler = (_event, data) => {
      this.mode = data.source;
      const p2pStats = data.p2p;
      const httpStats = data.http;
      this.playerNetworkInfo.downloadSpeed = (0,_common__WEBPACK_IMPORTED_MODULE_3__.bytes)(((p2pStats === null || p2pStats === void 0 ? void 0 : p2pStats.downloadSpeed) || 0) + (httpStats.downloadSpeed || 0)).join(' ');
      this.playerNetworkInfo.uploadSpeed = (0,_common__WEBPACK_IMPORTED_MODULE_3__.bytes)((p2pStats === null || p2pStats === void 0 ? void 0 : p2pStats.uploadSpeed) || 0).join(' ');
      this.playerNetworkInfo.totalDownloaded = (0,_common__WEBPACK_IMPORTED_MODULE_3__.bytes)(((p2pStats === null || p2pStats === void 0 ? void 0 : p2pStats.downloaded) || 0) + httpStats.downloaded).join(' ');
      this.playerNetworkInfo.totalUploaded = (0,_common__WEBPACK_IMPORTED_MODULE_3__.bytes)((p2pStats === null || p2pStats === void 0 ? void 0 : p2pStats.uploaded) || 0).join(' ');
      this.playerNetworkInfo.numPeers = p2pStats === null || p2pStats === void 0 ? void 0 : p2pStats.peersWithWebSeed;
      if (data.source === 'p2p-media-loader') {
        this.playerNetworkInfo.averageBandwidth = (0,_common__WEBPACK_IMPORTED_MODULE_3__.bytes)(data.bandwidthEstimate).join(' ') + '/s';
        this.playerNetworkInfo.downloadedFromServer = (0,_common__WEBPACK_IMPORTED_MODULE_3__.bytes)(httpStats.downloaded).join(' ');
        this.playerNetworkInfo.downloadedFromPeers = (0,_common__WEBPACK_IMPORTED_MODULE_3__.bytes)((p2pStats === null || p2pStats === void 0 ? void 0 : p2pStats.downloaded) || 0).join(' ');
      }
    };
    this.player().on('network-info', this.onNetworkInfoHandler);
    return this.containerEl;
  }
  dispose() {
    if (this.updateInterval) clearInterval(this.updateInterval);
    this.player().off('network-info', this.onNetworkInfoHandler);
    super.dispose();
  }
  toggle() {
    if (this.updateInterval) this.hide();else this.show();
  }
  show() {
    this.containerEl.style.display = 'block';
    this.updateInterval = setInterval(async () => {
      try {
        const options = this.mode === 'p2p-media-loader' ? this.buildHLSOptions() : await this.buildWebVideoOptions(); // Default
        this.populateInfoValues(options);
      } catch (err) {
        _root_helpers_logger__WEBPACK_IMPORTED_MODULE_1__.logger.error('Cannot update stats.', err);
        clearInterval(this.updateInterval);
      }
    }, this.intervalMs);
  }
  hide() {
    clearInterval(this.updateInterval);
    this.containerEl.style.display = 'none';
  }
  buildHLSOptions() {
    const p2pMediaLoader = this.player_.p2pMediaLoader();
    const level = p2pMediaLoader.getCurrentLevel();
    const codecs = level !== null && level !== void 0 && level.videoCodec || level !== null && level !== void 0 && level.audioCodec ? "".concat((level === null || level === void 0 ? void 0 : level.videoCodec) || '', " / ").concat((level === null || level === void 0 ? void 0 : level.audioCodec) || '') : undefined;
    const resolution = level !== null && level !== void 0 && level.height ? "".concat(level.height, "p").concat((level === null || level === void 0 ? void 0 : level.attrs['FRAME-RATE']) || '') : undefined;
    const buffer = this.timeRangesToString(this.player().buffered());
    let progress;
    let latency;
    let latencyFromEdge;
    if (this.options_.videoIsLive) {
      latency = (0,_peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_2__.secondsToTime)(p2pMediaLoader.getLiveLatency());
      latencyFromEdge = (0,_peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_2__.secondsToTime)(p2pMediaLoader.getLiveLatencyFromEdge());
    } else {
      progress = this.player().bufferedPercent();
    }
    return {
      playerNetworkInfo: this.playerNetworkInfo,
      resolution,
      codecs,
      buffer,
      latency,
      latencyFromEdge,
      progress
    };
  }
  async buildWebVideoOptions() {
    var _metadata$streams;
    const videoFile = this.player_.webVideo().getCurrentVideoFile();
    if (!this.metadataStore[videoFile.fileUrl]) {
      this.metadataStore[videoFile.fileUrl] = await fetch(videoFile.metadataUrl).then(res => res.json());
    }
    const metadata = this.metadataStore[videoFile.fileUrl];
    let colorSpace = 'unknown';
    let codecs = 'unknown';
    if (metadata !== null && metadata !== void 0 && (_metadata$streams = metadata.streams) !== null && _metadata$streams !== void 0 && _metadata$streams[0]) {
      const stream = metadata.streams[0];
      colorSpace = stream['color_space'] !== 'unknown' ? stream['color_space'] : 'bt709';
      codecs = stream['codec_name'] || 'avc1';
    }
    const resolution = (videoFile === null || videoFile === void 0 ? void 0 : videoFile.resolution.label) + (videoFile === null || videoFile === void 0 ? void 0 : videoFile.fps);
    const buffer = this.timeRangesToString(this.player_.buffered());
    const progress = this.player_.bufferedPercent();
    return {
      playerNetworkInfo: this.playerNetworkInfo,
      progress,
      colorSpace,
      codecs,
      resolution,
      buffer
    };
  }
  populateInfoBlocks() {
    this.playerMode = this.buildInfoRow(this.player().localize('Player mode'));
    this.p2p = this.buildInfoRow(this.player().localize('P2P'));
    this.uuid = this.buildInfoRow(this.player().localize('Video UUID'));
    this.viewport = this.buildInfoRow(this.player().localize('Viewport / Frames'));
    this.resolution = this.buildInfoRow(this.player().localize('Resolution'));
    this.volume = this.buildInfoRow(this.player().localize('Volume'));
    this.codecs = this.buildInfoRow(this.player().localize('Codecs'));
    this.color = this.buildInfoRow(this.player().localize('Color'));
    this.connection = this.buildInfoRow(this.player().localize('Connection Speed'));
    this.network = this.buildInfoRow(this.player().localize('Network Activity'));
    this.transferred = this.buildInfoRow(this.player().localize('Total Transfered'));
    this.download = this.buildInfoRow(this.player().localize('Download Breakdown'));
    this.bufferProgress = this.buildInfoRow(this.player().localize('Buffer Progress'));
    this.bufferState = this.buildInfoRow(this.player().localize('Buffer State'));
    this.liveLatency = this.buildInfoRow(this.player().localize('Live Latency'));
    this.infoListEl.appendChild(this.playerMode.root);
    this.infoListEl.appendChild(this.p2p.root);
    this.infoListEl.appendChild(this.uuid.root);
    this.infoListEl.appendChild(this.viewport.root);
    this.infoListEl.appendChild(this.resolution.root);
    this.infoListEl.appendChild(this.volume.root);
    this.infoListEl.appendChild(this.codecs.root);
    this.infoListEl.appendChild(this.color.root);
    this.infoListEl.appendChild(this.connection.root);
    this.infoListEl.appendChild(this.network.root);
    this.infoListEl.appendChild(this.transferred.root);
    this.infoListEl.appendChild(this.download.root);
    this.infoListEl.appendChild(this.bufferProgress.root);
    this.infoListEl.appendChild(this.bufferState.root);
    this.infoListEl.appendChild(this.liveLatency.root);
  }
  populateInfoValues(options) {
    const {
      playerNetworkInfo,
      progress,
      colorSpace,
      codecs,
      resolution,
      buffer,
      latency,
      latencyFromEdge
    } = options;
    const {
      downloadedFromServer,
      downloadedFromPeers
    } = playerNetworkInfo;
    const player = this.player();
    const videoQuality = player.getVideoPlaybackQuality();
    const vw = Math.max(document.documentElement.clientWidth || 0, window.innerWidth || 0);
    const vh = Math.max(document.documentElement.clientHeight || 0, window.innerHeight || 0);
    const pr = (window.devicePixelRatio || 1).toFixed(2);
    const vp = "".concat(vw, "x").concat(vh, "*").concat(pr);
    const {
      droppedVideoFrames,
      totalVideoFrames
    } = videoQuality;
    const frames = player.localize('{1} / {2} dropped of {3}', [vp, droppedVideoFrames + '', totalVideoFrames + '']);
    const duration = player.duration();
    let volume = "".concat(Math.round(player.volume() * 100));
    if (player.muted()) volume += player.localize(' (muted)');
    const networkActivity = playerNetworkInfo.downloadSpeed ? "".concat(playerNetworkInfo.downloadSpeed, " \u21D3 / ").concat(playerNetworkInfo.uploadSpeed, " \u21D1") : undefined;
    let totalTransferred = playerNetworkInfo.totalDownloaded ? "".concat(playerNetworkInfo.totalDownloaded, " \u21D3") : '';
    if (playerNetworkInfo.totalUploaded) {
      totalTransferred += "/ ".concat(playerNetworkInfo.totalUploaded, " \u21D1");
    }
    const downloadBreakdown = playerNetworkInfo.downloadedFromServer ? player.localize('{1} from servers · {2} from peers', [downloadedFromServer, downloadedFromPeers]) : undefined;
    const bufferProgress = progress !== undefined ? "".concat((progress * 100).toFixed(1), "% (").concat((progress * duration).toFixed(1), "s)") : undefined;
    const p2pEnabled = this.options_.p2pEnabled && this.mode === 'p2p-media-loader';
    this.setInfoValue(this.playerMode, this.mode);
    this.setInfoValue(this.p2p, player.localize(p2pEnabled ? 'enabled' : 'disabled'));
    this.setInfoValue(this.uuid, this.options_.videoUUID);
    this.setInfoValue(this.viewport, frames);
    this.setInfoValue(this.resolution, resolution);
    this.setInfoValue(this.volume, volume);
    this.setInfoValue(this.codecs, codecs);
    this.setInfoValue(this.color, colorSpace);
    this.setInfoValue(this.transferred, totalTransferred);
    this.setInfoValue(this.connection, playerNetworkInfo.averageBandwidth);
    this.setInfoValue(this.network, networkActivity);
    this.setInfoValue(this.download, downloadBreakdown);
    this.setInfoValue(this.bufferProgress, bufferProgress);
    this.setInfoValue(this.bufferState, buffer);
    if (latency && latencyFromEdge) {
      this.setInfoValue(this.liveLatency, player.localize('{1} (from edge: {2})', [latency, latencyFromEdge]));
    }
  }
  setInfoValue(el, value) {
    if (!value) {
      el.root.style.display = 'none';
      return;
    }
    el.root.style.display = 'block';
    if (el.value.innerText === value) return;
    el.value.innerText = value;
  }
  buildInfoRow(labelText) {
    const root = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('div');
    root.style.display = 'none';
    const label = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('div', {
      innerText: labelText
    });
    const value = video_js__WEBPACK_IMPORTED_MODULE_0___default().dom.createEl('span');
    root.appendChild(label);
    root.appendChild(value);
    return {
      root,
      value
    };
  }
  timeRangesToString(r) {
    let result = '';
    for (let i = 0; i < r.length; i++) {
      const start = Math.floor(r.start(i));
      const end = Math.floor(r.end(i));
      result += "[".concat((0,_peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_2__.secondsToTime)(start), ", ").concat((0,_peertube_peertube_core_utils__WEBPACK_IMPORTED_MODULE_2__.secondsToTime)(end), "] ");
    }
    return result;
  }
}
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerComponent('StatsCard', StatsCard);


/***/ }),

/***/ "./src/assets/player/shared/stats/stats-plugin.ts":
/*!********************************************************!*\
  !*** ./src/assets/player/shared/stats/stats-plugin.ts ***!
  \********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   StatsForNerdsPlugin: () => (/* binding */ StatsForNerdsPlugin)
/* harmony export */ });
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _stats_card__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./stats-card */ "./src/assets/player/shared/stats/stats-card.ts");


const Plugin = video_js__WEBPACK_IMPORTED_MODULE_0___default().getPlugin('plugin');
class StatsForNerdsPlugin extends Plugin {
  constructor(player, options) {
    super(player);
    this.player.ready(() => {
      player.addClass('vjs-stats-for-nerds');
    });
    this.statsCard = new _stats_card__WEBPACK_IMPORTED_MODULE_1__.StatsCard(player, options);
    // Copy options
    player.addChild(this.statsCard);
  }
  dispose() {
    if (this.statsCard) {
      this.statsCard.dispose();
      this.player.removeChild(this.statsCard);
    }
    super.dispose();
  }
  show() {
    this.statsCard.show();
  }
}
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerPlugin('stats', StatsForNerdsPlugin);


/***/ }),

/***/ "./src/assets/player/shared/upnext/end-card.ts":
/*!*****************************************************!*\
  !*** ./src/assets/player/shared/upnext/end-card.ts ***!
  \*****************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   EndCard: () => (/* binding */ EndCard)
/* harmony export */ });
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);

function getMainTemplate(options) {
  return "\n    <div class=\"vjs-upnext-top\">\n      <span class=\"vjs-upnext-headtext\">".concat(options.headText, "</span>\n      <div class=\"vjs-upnext-title\"></div>\n    </div>\n    <div class=\"vjs-upnext-autoplay-icon\">\n      <svg height=\"100%\" version=\"1.1\" viewbox=\"0 0 98 98\" width=\"100%\">\n        <circle class=\"vjs-upnext-svg-autoplay-circle\" cx=\"49\" cy=\"49\" fill=\"#000\" fill-opacity=\"0.8\" r=\"48\"></circle>\n        <circle class=\"vjs-upnext-svg-autoplay-ring\" cx=\"-49\" cy=\"49\" fill-opacity=\"0\" r=\"46.5\"\n                stroke=\"#FFFFFF\" stroke-width=\"4\" transform=\"rotate(-90)\"\n        ></circle>\n        <polygon class=\"vjs-upnext-svg-autoplay-triangle\" fill=\"#fff\" points=\"32,27 72,49 32,71\"></polygon></svg>\n    </div>\n    <span class=\"vjs-upnext-bottom\">\n      <span class=\"vjs-upnext-cancel\">\n        <button class=\"vjs-upnext-cancel-button\" tabindex=\"0\" aria-label=\"Cancel autoplay\">").concat(options.cancelText, "</button>\n      </span>\n      <span class=\"vjs-upnext-suspended\">").concat(options.suspendedText, "</span>\n    </span>\n  ");
}
const Component = video_js__WEBPACK_IMPORTED_MODULE_0___default().getComponent('Component');
class EndCard extends Component {
  constructor(player, options) {
    super(player, options);
    this.dashOffsetTotal = 586;
    this.dashOffsetStart = 293;
    this.interval = 50;
    this.upNextEvents = new (video_js__WEBPACK_IMPORTED_MODULE_0___default().EventTarget)();
    this.ticks = 0;
    this.totalTicks = this.options_.timeout / this.interval;
    this.onEndedHandler = () => {
      if (!this.options_.isDisplayed()) return;
      player.addClass('vjs-upnext--showing');
      this.showCard(canceled => {
        player.removeClass('vjs-upnext--showing');
        this.container.style.display = 'none';
        if (!canceled) {
          this.options_.next();
        }
      });
    };
    this.onPlayingHandler = () => {
      this.upNextEvents.trigger('playing');
    };
    player.on(['auto-stopped', 'ended'], this.onEndedHandler);
    player.on('playing', this.onPlayingHandler);
  }
  dispose() {
    if (this.onEndedHandler) this.player().off(['auto-stopped', 'ended'], this.onEndedHandler);
    if (this.onPlayingHandler) this.player().off('playing', this.onPlayingHandler);
    if (this.timeout) clearTimeout(this.timeout);
    super.dispose();
  }
  createEl() {
    const container = super.createEl('div', {
      className: 'vjs-upnext-content',
      innerHTML: getMainTemplate(this.options_)
    });
    this.container = container;
    container.style.display = 'none';
    this.autoplayRing = container.getElementsByClassName('vjs-upnext-svg-autoplay-ring')[0];
    this.title = container.getElementsByClassName('vjs-upnext-title')[0];
    this.cancelButton = container.getElementsByClassName('vjs-upnext-cancel-button')[0];
    this.suspendedMessage = container.getElementsByClassName('vjs-upnext-suspended')[0];
    this.nextButton = container.getElementsByClassName('vjs-upnext-autoplay-icon')[0];
    this.cancelButton.onclick = () => {
      this.upNextEvents.trigger('cancel');
    };
    this.nextButton.onclick = () => {
      this.upNextEvents.trigger('next');
    };
    return container;
  }
  showCard(cb) {
    this.autoplayRing.setAttribute('stroke-dasharray', "".concat(this.dashOffsetStart));
    this.autoplayRing.setAttribute('stroke-dashoffset', "".concat(-this.dashOffsetStart));
    this.title.innerText = this.options_.getTitle();
    if (this.totalTicks === 0) {
      return cb(false);
    }
    this.upNextEvents.one('cancel', () => {
      clearTimeout(this.timeout);
      this.timeout = undefined;
      cb(true);
    });
    this.upNextEvents.one('playing', () => {
      clearTimeout(this.timeout);
      this.timeout = undefined;
      cb(true);
    });
    this.upNextEvents.one('next', () => {
      clearTimeout(this.timeout);
      this.timeout = undefined;
      cb(false);
    });
    const goToPercent = percent => {
      const newOffset = Math.max(-this.dashOffsetTotal, -this.dashOffsetStart - percent * this.dashOffsetTotal / 2 / 100);
      this.autoplayRing.setAttribute('stroke-dashoffset', '' + newOffset);
    };
    const tick = () => {
      goToPercent(this.ticks++ * 100 / this.totalTicks);
    };
    const update = () => {
      if (this.options_.isSuspended()) {
        this.suspendedMessage.innerText = this.options_.suspendedText;
        goToPercent(0);
        this.ticks = 0;
        this.timeout = setTimeout(update.bind(this), 300); // checks once supsended can be a bit longer
      } else if (this.ticks >= this.totalTicks) {
        clearTimeout(this.timeout);
        this.timeout = undefined;
        cb(false);
      } else {
        this.suspendedMessage.innerText = '';
        tick();
        this.timeout = setTimeout(update.bind(this), this.interval);
      }
    };
    this.container.style.display = 'block';
    this.timeout = setTimeout(update.bind(this), this.interval);
  }
}
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerComponent('EndCard', EndCard);

/***/ }),

/***/ "./src/assets/player/shared/upnext/upnext-plugin.ts":
/*!**********************************************************!*\
  !*** ./src/assets/player/shared/upnext/upnext-plugin.ts ***!
  \**********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   UpNextPlugin: () => (/* binding */ UpNextPlugin)
/* harmony export */ });
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! video.js */ "./node_modules/video.js/core.js");
/* harmony import */ var video_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(video_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _end_card__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./end-card */ "./src/assets/player/shared/upnext/end-card.ts");


const Plugin = video_js__WEBPACK_IMPORTED_MODULE_0___default().getPlugin('plugin');
class UpNextPlugin extends Plugin {
  constructor(player, options) {
    super(player);
    const settings = {
      next: options.next,
      getTitle: options.getTitle,
      timeout: options.timeout,
      cancelText: player.localize('Cancel'),
      headText: player.localize('Up Next'),
      suspendedText: player.localize('Autoplay is suspended'),
      isDisplayed: options.isDisplayed,
      isSuspended: options.isSuspended
    };
    this.player.ready(() => {
      player.addClass('vjs-upnext');
    });
    const component = new _end_card__WEBPACK_IMPORTED_MODULE_1__.EndCard(player, settings);
    player.addChild(component);
    this.on('dispose', () => player.removeChild(component));
  }
}
video_js__WEBPACK_IMPORTED_MODULE_0___default().registerPlugin('upnext', UpNextPlugin);


/***/ }),

/***/ "./src/root-helpers/web-browser.ts":
/*!*****************************************!*\
  !*** ./src/root-helpers/web-browser.ts ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   isIOS: () => (/* binding */ isIOS),
/* harmony export */   isMobile: () => (/* binding */ isMobile),
/* harmony export */   isSafari: () => (/* binding */ isSafari)
/* harmony export */ });
function isIOS() {
  if (/iPad|iPhone|iPod/.test(navigator.platform)) {
    return true;
  }
  // Detect iPad Desktop mode
  return !!(navigator.maxTouchPoints && navigator.maxTouchPoints > 2 && navigator.platform.includes('MacIntel'));
}
function isSafari() {
  return /^((?!chrome|android).)*safari/i.test(navigator.userAgent);
}
function isMobile() {
  return /iPhone|iPad|iPod|Android/i.test(navigator.userAgent);
}


/***/ }),

/***/ "./src/shims/path.ts":
/*!***************************!*\
  !*** ./src/shims/path.ts ***!
  \***************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {



module.exports = __webpack_require__(/*! path-browserify */ "./node_modules/path-browserify/index.js");

/***/ })

}]);
//# sourceMappingURL=src_assets_player_peertube-player_ts.e5502a553fc1a9a4b721.chunk.js.map